	//    <Setting name="Port Production Max" value="32760"/>
import com.swath.*;
import com.swath.cmd.*;

import java.text.*;
//import java.util.*;

public class BuyDown extends UserDefinedScript {
	protected static final String HEADER1 = "---------------------------------------------"+SendString.RETURN_KEY;
	protected static final String HEADER2 = "[XXX] Buydown v1.0";
	private Planet[] planets;
	private Planet curPlanet;
	private int[] pAmounts;			// Port amounts
	private int[] pBuySell;			// But/Sell Indicators
	private Sector curSector;		// Curent Sector
	private Parameter planet;
	private Parameter BuyFuel;
	private Parameter BuyOrganics;
	private Parameter BuyEquipment;
	private Parameter BuyLimit;
	private Parameter ExpressMode;
	private boolean	status;
	private int sCreds;			// Starting Credits
	private int cCreds;			// Current Credits
	private int tCreds;			// Total Credits Spent.


	public String getName() { return "My Buy Down";	}
	public String getDescription() {return "Check your Computer Abort-display-on-keys setting (CN9), if you choose not "+
						"to run in express mode and this option is already set to ALL-KEYS "+
						"don't say I didn't warn you"; }

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.COMMAND_PROMPT)) {
			SetTextMode.exec(SetTextMode.COLOR_WHITE, SetTextMode.COLOR_BLACK, SetTextMode.MODE_NORMAL);
			PrintText.exec("\nMust be at the Command Prompt.\n");
			throw new ScriptException("Not at correct prompt");	
		}

		if (Swath.sector.portStatus() == Sector.NO_PORT) {
			SetTextMode.exec(SetTextMode.COLOR_WHITE, SetTextMode.COLOR_BLACK, SetTextMode.MODE_NORMAL);
			PrintText.exec("\nMust be a Port in the current sector.\n");
			throw new ScriptException("No Port Available");
		}			

		if (Swath.you.credits() < 1000000) {
			SetTextMode.exec(SetTextMode.COLOR_WHITE, SetTextMode.COLOR_BLACK, SetTextMode.MODE_NORMAL);
			PrintText.exec("\nMust have at least $1 Million Creds on hand.\n");
			throw new ScriptException("Not enough money.");
		}
			
		if (Swath.ship.holds() == 0) {
			SetTextMode.exec(SetTextMode.COLOR_WHITE, SetTextMode.COLOR_BLACK, SetTextMode.MODE_NORMAL);
			PrintText.exec("\nMust have at least one Hold.\n");
			throw new ScriptException("Not enough Holds");
		}

		planets = Swath.sector.planets();
		planet = new Parameter("Planet to Dump On");

		if (planets.length == 0) {	// ToDo: Allow for Buy-Jettison option.
			SetTextMode.exec(SetTextMode.COLOR_WHITE, SetTextMode.COLOR_BLACK, SetTextMode.MODE_NORMAL);
			PrintText.exec("\nThere must be a planet in the sector (with room).\n");
			throw new ScriptException("Planet not available.");
		}
	
		for(int i=0; i < planets.length; i++) {
			planet.addChoice(i,planets[i].toString());
		}

		planet.setCurrentChoice(0);

		BuyFuel = new Parameter("Buy Fuel");
		BuyFuel.setType(Parameter.BOOLEAN);
		BuyFuel.setBoolean(true);

		BuyOrganics = new Parameter("Buy Organics");
		BuyOrganics.setType(Parameter.BOOLEAN);
		BuyOrganics.setBoolean(true);

		BuyEquipment = new Parameter("Buy Equipment");
		BuyEquipment.setType(Parameter.BOOLEAN);
		BuyEquipment.setBoolean(true);
		
		BuyLimit = new Parameter("Buy Down Limit");
		BuyLimit.setType(Parameter.CHOICE);
		BuyLimit.addChoice(1,"Maximum");
		BuyLimit.addChoice(2,"Half");
		BuyLimit.addChoice(4,"Quarter");
		BuyLimit.setCurrentChoice(1);

		ExpressMode = new Parameter("Run Express Mode");
		ExpressMode.setType(Parameter.BOOLEAN);
		ExpressMode.setBoolean(true);
		
		registerParam(planet);
		registerParam(BuyFuel);
		registerParam(BuyOrganics);
		registerParam(BuyEquipment);
		registerParam(BuyLimit);
		registerParam(ExpressMode);
		return true;
	}	
	
	public boolean runScript() throws Exception {
		int iterations=0;				// Macro Cycles
		int divr=0;					// Divisor
		String s;

		EnterComputer.exec();
		ChangeSettings.exec(ChangeSettings.SPACE);
		LeaveComputer.exec();

		DisplaySector.exec();
		DisplayCurrentInfo.exec(false);

		curSector = Swath.getSector(Swath.sector.sector());		
		curPlanet = (Planet)(planets[planet.getCurrentChoice()]);		

		sCreds = Swath.you.credits();
		cCreds = Swath.you.credits();
		tCreds = 0;
		s = " ";
		
		divr = (int)(BuyLimit.getCurrentChoice());

		output(" Buy Down in progress"+SendString.RETURN_KEY+"Using Planet #"+curPlanet.id()+" "+curPlanet.name()+
			SendString.RETURN_KEY+" Starting Credits: "+NumberFormat.getCurrencyInstance().format(sCreds));

		if(isPortWorkable()) {
			for (int i = 2; i >= 0; i--) {
				if(pBuySell[i] == Sector.SELLING) {
					status=false;

					iterations = (pAmounts[i] / Swath.ship.holds())/divr;
					
					if((i==2) && (BuyEquipment.getBoolean())) {
						s = " Bought "+(iterations*Swath.ship.holds())+" Units of Equipment."+" Port had: "+pAmounts[i]+SendString.RETURN_KEY+"Starting Creds: "+NumberFormat.getCurrencyInstance().format(cCreds)+SendString.RETURN_KEY;
						status = BuyDownEQUIPMENT(iterations, curPlanet.id(), Swath.ship.holds());
					}
					else if ((i==1) && (BuyOrganics.getBoolean())) {
						s = " Bought "+(iterations*Swath.ship.holds())+" Units of Organics."+" Port had: "+pAmounts[i]+SendString.RETURN_KEY+"Starting Creds: "+NumberFormat.getCurrencyInstance().format(cCreds)+SendString.RETURN_KEY;
						status = BuyDownORGANICS(iterations, curPlanet.id(), Swath.ship.holds());
					}
					else if ((i==0) && (BuyFuel.getBoolean())) {
						s = " Bought "+(iterations*Swath.ship.holds())+" Units of Fuel Ore."+" Port had: "+pAmounts[i]+SendString.RETURN_KEY+"Starting Creds: "+NumberFormat.getCurrencyInstance().format(cCreds)+SendString.RETURN_KEY;
						status = BuyDownFUEL(iterations, curPlanet.id(), Swath.ship.holds());
					}
	
					if(status) {
						DisplayCurrentInfo.exec(false);
						while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(25); }
						tCreds= (cCreds-Swath.you.credits());
						cCreds=Swath.you.credits();

						output(s+" Credits Spent : "+NumberFormat.getCurrencyInstance().format(tCreds)+SendString.RETURN_KEY+
							 " Remaining     : "+NumberFormat.getCurrencyInstance().format(cCreds));
					}
					else {
						throw new ScriptException("Problem With BuyDown");									
					}
				}
			}
		}
		return true;
	}

	public void endScript(boolean finished) throws Exception { 
		// Nadda to do
	}

	private boolean isPortWorkable() throws Exception {
		int pclass;

		// 1/BBS 2/BSB 3/SBB 4/SSB 5/SBS 6/BSS 7/SSS 8/BBB
		pclass = Swath.sector.portClass();

		if (pclass > 7) {
			SetTextMode.exec(SetTextMode.COLOR_WHITE, SetTextMode.COLOR_BLACK, SetTextMode.MODE_NORMAL);	
			PrintText.exec("\nPort must not be one of the following Classes:\n");
			SetTextMode.exec(SetTextMode.COLOR_BLUE, SetTextMode.COLOR_BLACK, SetTextMode.MODE_NORMAL);	
			PrintText.exec("1 BBS\n2 BSB\n3 SBB\n4 SSB\n5 SBS\n6 BSS\n7 SSS\n");
			throw new ScriptException("Incorrect Port Class, Nothing to buy.");			
		}

		EnterComputer.exec();
		PortReport.exec(curSector);
		LeaveComputer.exec();

		pAmounts = curSector.portAmounts();
		pBuySell = curSector.portInfo();


		if (pAmounts.length ==3) {
			if (((BuyFuel.getBoolean() == (pBuySell[0] == Sector.SELLING)) && (Swath.ship.holds() < pAmounts[0])) || ((BuyOrganics.getBoolean()== (pBuySell[1] == Sector.SELLING)) && (Swath.ship.holds() < pAmounts[1])) || ((BuyEquipment.getBoolean() == (pBuySell[2] == Sector.SELLING)) && (Swath.ship.holds() < pAmounts[2]))) {
				//The line above is long. It determines if the Port sells the selected Buy products
				//and if the amount(s) are high enough.
			} else {
				return false;
			}					
		}
		return true;
	}

	private boolean BuyDownFUEL(int I, int P, int H) throws Exception {
		// Translation: Port, trade, buy H holds, pay whatever, 
		//              Land on P, leave H-holds, quit planet.	
	  	//		p^M255^M^Ml31^Mtnl1255^Mq	
		JettisonCargo.exec();	
		SendMacro.exec("P^M"+H+"^M^ML"+P+"^MTNL1"+H+"^MQ", I, ExpressMode.getBoolean());
		while (Swath.main.prompt() != Swath.COMMAND_PROMPT) {
			Thread.sleep(25);
		}
		return true;
	}

	private boolean BuyDownORGANICS(int I, int P, int H) throws Exception {	
		// Translation: same as above except we're dealing with Organics
		//		pt0^M255^M^Ml31^Mtnl2255^Mq
		JettisonCargo.exec();	
		SendMacro.exec("PT0^M"+H+"^M^ML"+P+"^MTNL2"+H+"^MQ", I, ExpressMode.getBoolean());
		while (Swath.main.prompt() != Swath.COMMAND_PROMPT) {
			Thread.sleep(25);
		}
		return true;
	}

	private boolean BuyDownEQUIPMENT(int I, int P, int H) throws Exception {	
		// Translation: ditto
		//		pt0^M0^M255^M^Ml31^Mtnl3255^Mq
		JettisonCargo.exec();	
		SendMacro.exec("PT0^M0^M"+H+"^M^ML"+P+"^MTNL3"+H+"^MQ", I, ExpressMode.getBoolean());
		while (Swath.main.prompt() != Swath.COMMAND_PROMPT) {
			Thread.sleep(25);
		}

		return true;
	}

	public void output(String msg) throws Exception {
		String m = msg;

		SendString.exec("'"+SendString.RETURN_KEY+HEADER1+HEADER2+SendString.RETURN_KEY);
		SendString.exec(m+SendString.RETURN_KEY);
		SendString.exec(HEADER1+SendString.RETURN_KEY);
	}
}



