import com.swath.*;
import com.swath.cmd.*;
import java.util.*;
import java.text.*;

public class Harvester extends UserDefinedScript {
	protected String PName = "<<<DRUiDIA>>>";
	private Parameter output;		// send msg's
	private Parameter ignoreore;		//
	private Planet Basket;			// Planet we're filling
	private Planet ToEmpty;			// Planet to empty
	private int FMax = 0;			// Maximum product Basket can hold 
	private int OMax = 0;			//
	private int EMax = 0;			//
	private int owner;			// indicates Personal/Corp context
	private PlanetClass[] planets;
	private int[] MaxAmounts;
	private int[] PAmounts;
	private int FTot=0;
	private int OTot=0;
	private int ETot=0;

	public String getName() {		return "Planet Harvester v1.2"; }
	public String getDescription() {	return "Planet Harvester v1.2"; }

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.PLANET_PROMPT)) { throw new ScriptException("Not at correct prompt."); }
		planets = Swath.getAllPlanetClasses();

		output = new Parameter("Output To");
		output.setType(Parameter.CHOICE);
		output.addChoice(0, "Swath Console");
		output.addChoice(1, "SubSpace Radio");
		output.addChoice(2, "None");
		output.setCurrentChoice(1);
		registerParam(output);

		ignoreore = new Parameter("Ignore Ore Over 10k");
		ignoreore.setType(Parameter.BOOLEAN);
		ignoreore.setBoolean(false);
		registerParam(ignoreore);

		owner = Swath.PERSONAL;
		return true;
	}	
	
	public boolean runScript() throws Exception {
		int[] pidAmounts;

		UpdateShipSpec();

		Basket = Swath.getPlanet(Swath.main.currPlanet());
		PAmounts = Basket.productAmounts();

		output("---[Harvestor v1.2]---- Sector "+Swath.sector.sector()+" Filling Planet: "+Basket.name()+" #"+Basket.id());

		if (!getMaxAmounts()) { 
			output("Unable to obtain Planet Maximum Product Amounts."); 
			throw new ScriptException("Unable to obtain Planet Maximum Product Amounts."); 
		}	

		LiftOff.exec();

		while ((Swath.ship.atomicDevices() > 0)&& (Swath.ship.genesisTorpedos() > 0 )) {
			if (!(FastCreateandLand.exec(PName, Swath.CORPORATE))) {
				throw new ScriptException("Unable to create and land.");
			}

			ToEmpty = Swath.getPlanet(Swath.main.currPlanet());
							
			pidAmounts = ToEmpty.productAmounts();
			output("[][] "+ToEmpty.className()+" "+ToEmpty.type()+" [F/O/E]: "+NumberFormat.getInstance().format(pidAmounts[Swath.FUEL_ORE])+" / "+NumberFormat.getInstance().format(pidAmounts[Swath.ORGANICS])+" / "+NumberFormat.getInstance().format(pidAmounts[Swath.EQUIPMENT]));

			if ((pidAmounts[Swath.FUEL_ORE] > 0) || (pidAmounts[Swath.ORGANICS] > 0) || (pidAmounts[Swath.EQUIPMENT] > 0)) {
			
				if (ignoreore.getBoolean() && (pidAmounts[Swath.FUEL_ORE] > 10000)) {
					output("**** Ignoring Ore ****");
				} else {
					if (pidAmounts[Swath.FUEL_ORE] > 0) {
						output("+--Moving "+NumberFormat.getInstance().format(pidAmounts[Swath.FUEL_ORE])+" units of FUEL ORE");
						Mover(Swath.FUEL_ORE, pidAmounts[Swath.FUEL_ORE]);
						FTot = FTot + pidAmounts[Swath.FUEL_ORE];
						FMax = FMax - pidAmounts[Swath.FUEL_ORE];
					}
				}

				if (pidAmounts[Swath.ORGANICS] > 0) {
					output("+--Moving "+NumberFormat.getInstance().format(pidAmounts[Swath.ORGANICS])+" units of ORGANICS");
					Mover(Swath.ORGANICS, pidAmounts[Swath.ORGANICS]);
					OTot = OTot + pidAmounts[Swath.ORGANICS];
					OMax = OMax - pidAmounts[Swath.ORGANICS];
				}

				if (pidAmounts[Swath.EQUIPMENT] > 0) {
					output("+--Moving "+NumberFormat.getInstance().format(pidAmounts[Swath.EQUIPMENT])+" units of EQUIPMENT");
					Mover(Swath.EQUIPMENT, pidAmounts[Swath.EQUIPMENT]);
					ETot = ETot + pidAmounts[Swath.EQUIPMENT];
					EMax = EMax - pidAmounts[Swath.EQUIPMENT];
				}
				output("---Farmed----+--ORE: "+NumberFormat.getInstance().format(FTot)+"---+---ORG: "+NumberFormat.getInstance().format(OTot)+"--+--EQU: "+NumberFormat.getInstance().format(ETot)+"---");
			}
			SendString.exec("Z D Y /#");
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(100); }

			output("Turns "+Swath.you.turns()+" [] Atomics "+Swath.ship.atomicDevices()+" [] Torpedos "+Swath.ship.genesisTorpedos()+" [] Shields "+Swath.ship.shields());
			WhoisOnline();
		}		

		
		return true;
	}
	
	public void Mover(int Prod, int HowMuch) throws Exception {
		int holds = Swath.ship.holds();	// Ships Holds
		int Carry = 0;			// what we're taking in a trip
		int foe = 0;
		int amnt = 0;			// total amount
		int iter = 0;
		int legs = 0;
		int last = 0;
		int t = 0;

		amnt = HowMuch;
		
		switch (Prod) {
			case Swath.FUEL_ORE:
				foe = 1;
				if (amnt > FMax) { amnt = FMax; }
				break;
			case Swath.ORGANICS:
				foe = 2;
				if (amnt > OMax) { amnt = OMax; }
				break;
			case Swath.EQUIPMENT:
				foe = 3;
				if (amnt > EMax) { amnt = EMax; }
				break;
			default:
				output("Attempted to Move non-existant product, contact your service dealer");
				throw new ScriptException("Unkown Product. Not known FOE");
		}


		iter = amnt / holds;					// Number of Macro cycles
		t = (iter * holds);		

		if (t < amnt) {						// Round about way of getting remainder
			last = amnt-t;					// 10,000 / 255holds=39.215
		}								// last = 10,000 - (39*255) = 9945
										// last = 55
		if (iter > 100) {						// do the job in legs
			while (iter > 0) {				// 
				if (iter > 100) {				// if iter is still > 100
					legs = 100;				// do another 100 cycle leg
					iter = iter-100;			//
				} else {					// else do what ever remains
					legs = iter;
					iter = 0;
				}
				SendMacro.exec("TNT"+foe+holds+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",legs,false);
			}
		} else {							// there isn't more than 100 cycles
			SendMacro.exec("TNT"+foe+holds+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",iter,false);
		}

		if (last > 0) {						// get last little bit
			SendMacro.exec("TNT"+foe+last+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",1,false);
		}
	}

	public boolean getMaxAmounts() throws Exception {
		for (int i = 0; i < planets.length; i++) {
			if (planets[i].name().equals(Basket.className())) {
				MaxAmounts = planets[i].maxAmounts();
				FMax = MaxAmounts[Swath.FUEL_ORE] - PAmounts[Swath.FUEL_ORE];
				OMax = MaxAmounts[Swath.ORGANICS] - PAmounts[Swath.ORGANICS];
				EMax = MaxAmounts[Swath.EQUIPMENT]- PAmounts[Swath.EQUIPMENT];
				output(" Planet can house [F/O/E] "+NumberFormat.getInstance().format(FMax)+" / "+NumberFormat.getInstance().format(OMax)+" / "+NumberFormat.getInstance().format(EMax));
				return true;	
			}
		}
		return false;
	}
	public void UpdateShipSpec() throws Exception {
		if (atPrompt(Swath.PLANET_PROMPT)) {
			Planet o = Swath.getPlanet(Swath.main.currPlanet());
			LiftOff.exec();
			JettisonCargo.exec();
			DisplayCurrentInfo.exec();
			EnterComputer.exec();
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			ChangeSettings.exec(ChangeSettings.ALL_KEYS);	// MD's userdfined routine
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			SendString.exec(";");
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			LeaveComputer.exec();
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(50); }
			Land.exec(o);
		}
	}

	public void WhoisOnline() throwsException {
		String s = "Who's Playing: ";
		Trader[] w = Whois.exec();

		if (w.length > 1) {
			for (int i = 0; i < w.length; i++) {
				s = s + w[i] + " / ";
			}
		} else {
			s = s+"No One";
		}
		output(s);
	}

	public void output(String message) throws Exception {
		String m = message;

		if (output.getCurrentChoice() == 0) {
			UserAlert.exec(m, UserAlert.TYPE_INFORMATION);		
		} else if (output.getCurrentChoice() == 1) {
			SendSSRadioMessage.exec(m);
		} else {
			// Do nothing
		}
	}
}


