import com.swath.*;
import com.swath.cmd.*;
import java.util.*;
import java.text.*;

public class Harvester extends UserDefinedScript {
	protected static final String Ver = " v2.0a";
	protected static final int CredLimit = 10000;
	protected String PName = "<<<DRUiDIA>>>";
	private Parameter refurb;		// Stardock indicator
	private Parameter via;			//Get to SD via
	private int ivia;
	private Parameter output;		// send msg's
	private Parameter ignoreore;		//
	private Parameter buyTorps;		// Number of Torpedos to buy
	private Parameter buyAtomics;		// Number of Detonators to buy
	private Planet Basket;			// Planet we're filling
	private Planet ToEmpty;			// Planet to empty
	private int FMax = 0;			// Maximum product Basket can hold 
	private int OMax = 0;			//
	private int EMax = 0;			//
	private int owner;			// indicates Personal/Corp context
	private PlanetClass[] planets;
	private int[] MaxAmounts;
	private int[] PAmounts;
	private int FTot=0;
	private int OTot=0;
	private int ETot=0;

	public String getName() {		return "Planet Harvester"+Ver; }
	public String getDescription() {	return "Planet Harvester"+Ver; }

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.PLANET_PROMPT)) { throw new ScriptException("Not at correct prompt."); }

		if(Swath.sector.fighters() <= 0 || !(Swath.sector.ftrOwner().isYou() || Swath.sector.ftrOwner().isYourCorporation())){
			throw new ScriptException("You must place fighters that you own in the starting sector..");
		}
		if(Swath.ship.transWarpDrive() == Ship.NO_TWD){
			throw new ScriptException("Ship MUST have transwarp drive..");
		}

		planets = Swath.getAllPlanetClasses();

		refurb = new Parameter("Star Dock");
		refurb.setType(Parameter.INTEGER);
		refurb.setIntegerRange(1, Swath.main.sectors());
		refurb.setInteger(Swath.main.stardock());
		registerParam(refurb);		

		if (Swath.you.alignment() < 1000) {
			via = new Parameter("Get To SD via");
			via.setType(Parameter.INTEGER);
			via.setIntegerRange(11, Swath.main.sectors());
			via.setInteger(11);
			registerParam(via);
		}

		output = new Parameter("Output To");
		output.setType(Parameter.CHOICE);
		output.addChoice(0, "Swath Console");
		output.addChoice(1, "SubSpace Radio");
		output.addChoice(2, "None");
		output.setCurrentChoice(1);
		registerParam(output);

		buyTorps = new Parameter("Buy How Many Torpedoes");
		buyTorps.setType(Parameter.INTEGER);
		buyTorps.setIntegerRange(1, 20);
		buyTorps.setInteger(20);
		registerParam(buyTorps);

		buyAtomics = new Parameter("Buy How Many Detonators");
		buyAtomics.setType(Parameter.INTEGER);
		buyAtomics.setIntegerRange(1, 20);
		buyAtomics.setInteger(20);
		registerParam(buyAtomics);

		ignoreore = new Parameter("Ignore Ore Over 10k");
		ignoreore.setType(Parameter.BOOLEAN);
		ignoreore.setBoolean(false);
		registerParam(ignoreore);

		owner = Swath.PERSONAL;
		return true;
	}	

	
	public boolean runScript() throws Exception {
		int[] pidAmounts;

		if (Swath.you.alignment() < 1000) {
			ivia = via.getInteger();
		}

		UpdateShipSpec();

		Basket = Swath.getPlanet(Swath.main.currPlanet());
		PAmounts = Basket.productAmounts();

		output("[Harvestor"+Ver+"]---- Sector "+Swath.sector.sector()+" Filling Planet: "+Basket.name()+" #"+Basket.id());

		if (!getMaxAmounts()) { 
			output("Unable to obtain Planet Maximum Product Amounts."); 
			throw new ScriptException("Unable to obtain Planet Maximum Product Amounts."); 
		}	

		LiftOff.exec();

		while (Swath.you.credits() > CredLimit) {
			while ((Swath.ship.atomicDevices() > 0)&& (Swath.ship.genesisTorpedos() > 0 )) {
				if (!(FastCreateandLand.exec(PName, Swath.CORPORATE))) {
					throw new ScriptException("Unable to create and land.");
				}

				ToEmpty = Swath.getPlanet(Swath.main.currPlanet());
							
				pidAmounts = ToEmpty.productAmounts();
				output("[][] "+ToEmpty.className()+" "+ToEmpty.type()+" [F/O/E]: "+NumberFormat.getInstance().format(pidAmounts[Swath.FUEL_ORE])+" / "+NumberFormat.getInstance().format(pidAmounts[Swath.ORGANICS])+" / "+NumberFormat.getInstance().format(pidAmounts[Swath.EQUIPMENT]));

				if ((pidAmounts[Swath.FUEL_ORE] > 0) || (pidAmounts[Swath.ORGANICS] > 0) || (pidAmounts[Swath.EQUIPMENT] > 0)) {
			
					if (ignoreore.getBoolean() && (pidAmounts[Swath.FUEL_ORE] > 10000)) {
						output("**** Ignoring Ore Over 10k ****");
					} else {
						if (pidAmounts[Swath.FUEL_ORE] > 0) {
							output("+--Moving "+NumberFormat.getInstance().format(pidAmounts[Swath.FUEL_ORE])+" units of FUEL ORE");
							Mover(Swath.FUEL_ORE, pidAmounts[Swath.FUEL_ORE]);
							FTot = FTot + pidAmounts[Swath.FUEL_ORE];
							FMax = FMax - pidAmounts[Swath.FUEL_ORE];
						}
					}

					if (pidAmounts[Swath.ORGANICS] > 0) {
						output("+--Moving "+NumberFormat.getInstance().format(pidAmounts[Swath.ORGANICS])+" units of ORGANICS");
						Mover(Swath.ORGANICS, pidAmounts[Swath.ORGANICS]);
						OTot = OTot + pidAmounts[Swath.ORGANICS];
						OMax = OMax - pidAmounts[Swath.ORGANICS];
					}

					if (pidAmounts[Swath.EQUIPMENT] > 0) {
						output("+--Moving "+NumberFormat.getInstance().format(pidAmounts[Swath.EQUIPMENT])+" units of EQUIPMENT");
						Mover(Swath.EQUIPMENT, pidAmounts[Swath.EQUIPMENT]);
						ETot = ETot + pidAmounts[Swath.EQUIPMENT];
						EMax = EMax - pidAmounts[Swath.EQUIPMENT];
					}
					output("---Farmed----+--ORE: "+NumberFormat.getInstance().format(FTot)+"---+---ORG: "+NumberFormat.getInstance().format(OTot)+"--+--EQU: "+NumberFormat.getInstance().format(ETot)+"---");
				}
				SendString.exec("Z D Y /#");
				while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(100); }

				output("Turns "+Swath.you.turns()+" [] Atomics "+Swath.ship.atomicDevices()+" [] Torpedos "+Swath.ship.genesisTorpedos()+" [] Shields "+Swath.ship.shields());
				WhosPlaying();
			}
			getMaxAmounts();
			ReFurb();
			output("Turns "+Swath.you.turns()+" [] Atomics "+Swath.ship.atomicDevices()+" [] Torpedos "+Swath.ship.genesisTorpedos()+" [] Shields "+Swath.ship.shields());
		}
		return true;
	}


	public void ReFurb() throws Exception {
		int iwarp = 0;

		if(Swath.sector.fighters() <= 0 || !(Swath.sector.ftrOwner().isYou() || Swath.sector.ftrOwner().isYourCorporation())){
			throw new ScriptException("You must place fighters that you own in the starting sector..");
		}
		if(Basket.productAmounts()[Swath.FUEL_ORE] < Swath.ship.holds()) {
			output("Not enough fuel on planet to refurb with");
			throw new ScriptException("Not Enough Fuel On Planet..");
		}

		output("--------[REFURBING]----------");

		if(Swath.you.credits() > CredLimit){
			Land.exec(Basket);
			TakeLeaveProducts.exec(Swath.ship.emptyHolds(),0,0);
			LiftOff.exec();

			try {
				if (Swath.you.alignment() > 1000) {
					TransWarp.exec(refurb.getInteger());
				} else {
					TransWarp.exec(ivia);
				}
			}
			catch (Exception e) {
				output("Unable to Refurb. Check Alignment or Jump Sector.");
				throw new ScriptException("Unable to Furb");		
			}

			if (ivia > 0) { 
				Move.exec(refurb.getInteger()); 
				//FastMove.exec(refurb.getInteger(), 1, 0, 0, false, true );		
			}
		
			if (Swath.sector.sector() != refurb.getInteger()) {
				output("Unable to reach StarDock");
				throw new ScriptException("Unable to to Refurb");		}

			LandOnStarDock.exec(true);
		
			SendMacro.exec("ha"+buyTorps.getInteger()+"^mt"+buyAtomics.getInteger()+"^mqq/", 1, false);	// Run once, Express=false
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(50); }

			try {
				TransWarp.exec(Basket.sector());
			}
			catch (Exception e) {
				output("Unable to warp home.");
				throw new ScriptException("Unable to warp home");
			}
			JettisonCargo.exec();				
		}
	}
	
	public void Mover(int Prod, int HowMuch) throws Exception {
		int holds = Swath.ship.holds();	// Ships Holds
		int Carry = 0;			// what we're taking in a trip
		int foe = 0;
		int amnt = 0;			// total amount
		int iter = 0;
		int legs = 0;
		int last = 0;
		int t = 0;

		amnt = HowMuch;
		
		switch (Prod) {
			case Swath.FUEL_ORE:
				foe = 1;
				if (amnt > FMax) { amnt = FMax; }	// This prevents us from trying to  put
				break;					// priduct on the planet than the Maximum
			case Swath.ORGANICS:				// If the planet is full ?Max will be zero.
				foe = 2;
				if (amnt > OMax) { amnt = OMax; }
				break;
			case Swath.EQUIPMENT:
				foe = 3;
				if (amnt > EMax) { amnt = EMax; }
				break;
			default:
				output("Attempted to Move non-existant product, contact your service dealer");
				throw new ScriptException("Unkown Product. Not known FOE");
		}


		iter = amnt / holds;					// Number of Macro cycles
		t = (iter * holds);					// iter will be zero if the planet's full.

		if (t < amnt) {						// Round about way of getting remainder
			last = amnt-t;					// 10,000 / 255holds=39.215
		}								// last = 10,000 - (39*255) = 9945
										// last = 55
		if (iter > 100) {						// do the job in legs
			while (iter > 0) {				// 
				if (iter > 100) {				// if iter is still > 100
					legs = 100;				// do another 100 cycle leg
					iter = iter-100;			//
				} else {					// else do what ever remains
					legs = iter;
					iter = 0;
				}
				SendMacro.exec("TNT"+foe+holds+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",legs,false);
			}
		} else {							// there isn't more than 100 cycles
			SendMacro.exec("TNT"+foe+holds+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",iter,false);
		}

		if (last > 0) {						// get last little bit
			SendMacro.exec("TNT"+foe+last+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",1,false);
		}
	}

	public boolean getMaxAmounts() throws Exception {
		for (int i = 0; i < planets.length; i++) {
			if (planets[i].name().equals(Basket.className())) {
				MaxAmounts = planets[i].maxAmounts();
				FMax = MaxAmounts[Swath.FUEL_ORE] - PAmounts[Swath.FUEL_ORE];
				OMax = MaxAmounts[Swath.ORGANICS] - PAmounts[Swath.ORGANICS];
				EMax = MaxAmounts[Swath.EQUIPMENT]- PAmounts[Swath.EQUIPMENT];
				output(" Planet can house [F/O/E] "+NumberFormat.getInstance().format(FMax)+" / "+NumberFormat.getInstance().format(OMax)+" / "+NumberFormat.getInstance().format(EMax));
				return true;	
			}
		}
		return false;
	}
	public void UpdateShipSpec() throws Exception {
		if (atPrompt(Swath.PLANET_PROMPT)) {
			Planet o = Swath.getPlanet(Swath.main.currPlanet());
			LiftOff.exec();
			JettisonCargo.exec();
			DisplayCurrentInfo.exec();
			EnterComputer.exec();
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			ChangeSettings.exec(ChangeSettings.ALL_KEYS);	// MD's userdfined routine
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			SendString.exec(";");
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			LeaveComputer.exec();
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(50); }
			Land.exec(o);
		}
	}

	public void WhosPlaying() throws Exception {
		Trader[] w; 
		String s = "Who's Playing: ";

		w = ShowWhoIsPlaying.exec();

		for (int i = 0; i < w.length; i++) {
			s = s + w[i].name() + ", ";
		}

		output(s);
	}

	public void output(String message) throws Exception {
		String m = message;

		if (output.getCurrentChoice() == 0) {
			UserAlert.exec(m, UserAlert.TYPE_INFORMATION);		
		} else if (output.getCurrentChoice() == 1) {
			SendSSRadioMessage.exec(m);
		} else {
			// Do nothing
		}
	}
}


