import com.swath.*;
import com.swath.cmd.*;
import java.util.*;
import java.text.*;

public class Harvester extends UserDefinedScript {
	protected String PName = "<<<DRUiDIA>>>";
	private Parameter output;		// send msg's
	private Parameter refurb;		// Stardock indicator
	private Planet Basket;			// Planet we're filling
	private Planet ToEmpty;			// Planet to empty
	private int FMax = 0;			// Maximum product Basket can hold 
	private int OMAx = 0;			//
	private int EMax = 0;			//
	private int Torps = 0;			// Torp/Atomics to buy each trip 
	private int Atoms = 0;			//
	private int owner;			// indicates Personal/Corp context
	private PlanetClass[] planets;
	private int[] MaxAmounts;
	private int[] PAmounts;
	private Sector sector;			// Basket Sector #

	public String getName() {		return "Planet Trade List"; }
	public String getDescription() {	return "Planetary Trade by List"; }

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.PLANET_PROMPT)) {
			throw new ScriptException("Not at correct prompt.");	
		}

		planets = Swath.getAllPlanetClasses();

		refurb = new Parameter("Star Dock");
		refurb.setType(Parameter.INTEGER);
		refurb.setIntegerRange(1, Swath.main.sectors());
		refurb.setInteger(Swath.main.stardock());
		registerParam(refurb);		

		output = new Parameter("Output To");
		output.setType(Parameter.CHOICE);
		output.addChoice(0, "Swath Console");
		output.addChoice(1, "SubSpace Radio");
		output.addChoice(2, "None");
		output.setCurrentChoice(0);
		registerParam(output);

		if (Swath.you.corporation() != null) {
			owner = Swath.CORPORATE;
		else
			owner = Swath.PERSONAL;
		}
		return true;
	}	
	
	public boolean runScript() throws Exception {
		int pid = 0;
		int[] pidAmounts;

		UpdateShipSpec();

		sector = Swath.getSector(Swath.sector.sector());

		Torps = Swath.ship.genesisTorpedos();		// These values will be used to indicate
		Atoms = Swath.ship.atomicDevices();			// howmany to repurchase at SD.

		Basket = Swath.getPlanet(Swath.main.currPlanet());

		PAmounts = Basket.productAmounts();

		if (!getMaxAmounts()) {
			throw new ScriptException("Unable to obtain Planet Maximum Product Amounts.");
		}	

		LaunchGenesisTorpedo.exec(PName, owner);
	
		pid = GetNewPlanet();

		if (pid != 0) { throw new ScriptException("Unable to ascertain "+PName+"'s ID"); }

		Land.exec(pid);
		ToEmpty = Swath.getPlanet(Swath.main.currPlanet());

		pidAmounts

		MoveToSD();
		BuyItems.exec(BuyItems.ATOMIC_DETONATORS,5);
		BuyItems.exec(BuyItems.GENESIS_TORPEDOES,5);
		ReturnFromSD();

		return true;
	}


	private int GetNewPlanet() throws Exception {
		if (atPrompt(Swath.COMMAND_PROMPT)) {
			DisplaySector.exec();
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(25); }

			// Just to get Planet data
			SendString.exec("L");
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(50); }
			SendString.exec("Q";
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(50); }

			Planet[] p = Swath.sector.planets();
		
			for(i = 0; i < p.length; i++) {
				if (p[i].name().equals(PName)) {
					return p[i].id();
				}
			}
		}
		return 0;
	}

	private boolean getMaxAmounts() throws Exception {
		for (int i = 0; i < planets.length; i++) {
			if (planets[i].name().equals(Basket.className())) {
				MaxAmounts = planets[i].maxAmounts();
				FMax = MaxAmounts[Swath.FUEL_ORE] - PAmounts[Swath.FUEL_ORE];
				OMax = MaxAmounts[Swath.ORGANICS] - PAmounts[Swath.ORGANICS];
				EMax = MaxAmounts[Swath.EQUIPMENT]- PAmounts[Swath.EQUIPMENT];
				output("Planet has room for: Fuel Ore:"+FMax+" Organics:"+OMax+" Equipment:"+EMax);
				return true;	
			}
		}
		return false;
	}

	private void output(String message) throws Exception {
		String m = message;

		if (output.getCurrentChoice() == 0) {
			UserAlert.exec(m, UserAlert.TYPE_INFORMATION);		
		} else if (output.getCurrentChoice() == 1) {
			SendSSRadioMessage.exec(m);
		} else {
			// Do nothing
		}
	}

	public void UpdateShipSpec() throws Exception {
		if (atPrompt(Swath.PLANET_PROMPT)) {
			EnterCitadel.exec();
			EnterComputer.exec();
			SendString.exec(";");
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			LeaveComputer.exec();
			while (Swath.main.prompt() != Swath.CITADEL_PROMPT) { Thread.sleep(50); }
			SendString.exec("i");
			while (Swath.main.prompt() != Swath.CITADEL_PROMPT) {  Thread.sleep(50); }
			LeaveCitadel.exec();
		}
	}

	public void endScript(boolean finished) throws Exception {
		// Nadda to do
	}


	public void ReturnFromSD() throws Exception {
		if((Swath.ship.transWarpDrive() != Ship.NO_TWD) && (Swath.ship.fuel() > 0){
			LeaveStarDock.exec();
			TransWarp.exec(Basket);
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(55); }
		} else {
			PrintTrace.exec("Unable to safely leave StarDock");
			endScript();
		}
	}

	public void MoveToSD() throws Exception {
		int SD = refurb.getInteger();
 		int here = Swath.main.currSector();

		if (Swath.sector.fighters() == 0) {
			DropTakeFighters.exec(1, owner, Swath.TOLL_FTRS);
		}

		if(Swath.ship.fuel() < Swath.ship.holds()){
     	  		JettisonCargo.exec();
			Land.exec(Basket);
			TakeLeaveProducts.exec(Swath.ship.holds(),0,0);
			LiftOff.exec();
		}		

		while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(55); }
		
		if ((Tools.findRoute(here,SD).length > 2) || (Tools.findRoute(here,SD).length == 0)) {
			SendString.exec("CF\r"+dest+"\rQ");
			Thread.sleep(1000);
		}
		
		while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(25); }
		
		int[] path = Tools.findRoute(here,SD);
		
		for (int i = 1; i < path.length; i++) {
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(25); }

			Move.exec(path[i]);

			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(25); }
		}

		try { 
			LandOnStarDock.exec(true);	//remove any limpet
		}
		catch (Throwable t) {
			PrintTrace.exec("Not in expected sector, unable to dock at SD");
			endScript();
		}

	}
}