import com.swath.*;
import com.swath.cmd.*;
import java.util.*;
import java.text.*;

public class Harvestor31 extends UserDefinedScript {
	   protected static final String Ver = " v1.0b";
	   protected static final int CredLimit = 1000000;
	   protected String PName = "<<< Terra FARMA >>>";
	   private Parameter furbsector;				//StarDock
         private Parameter treasury;				//Use Funds in Treasury?
	   private Parameter output;					//Send Spam
	   private Parameter verbose;					//Spit out detailed data/info
	   private Parameter buyTorps;				//Number of Gen Torps to buy
	   private Parameter buyAtomics;				//Number of Atomics to buy
	   private Planet Basket;					//Pleanet we're filling
	   private Planet ToEmpty;					//Planet to empty
	   private int Fonhand = 0;					//Basket Product Levels
	   private int Oonhand = 0;
	   private int Eonhand = 0;
	   private int FMax = 0;					//Max Amounts planet can hold
	   private int OMax = 0;
	   private int EMax = 0;
	   private int owner;						//Persaonl/Corp Flag
	   private PlanetClass[] planets;
	   private Planet[] secPlanets;				//Sector Planets
	   private int[] MaxAmounts;
	   private int[] BAmounts;
	   private int FTot = 0;					//Running Totals
	   private int OTot = 0;
	   private int ETot = 0;
	   private int furb = 0;

		public String getNAme() {		return "Terra FARMa "+Ver;}
		public String getDescription() {	return "<H2>LoneStars TerraFARMa "+Ver+"</H2>\n<b>TerraFARM "+Ver+" - Requires a Commished Blue - need not be Fed-Safe\n\n</b><blockquote><p align=\"left\"><small><b>Options:</b></small></p><ol><li><p align=\"left\"><small>Stardock might not be known to Swath, so enter  Sector number<br>" +
				"if necessary. Or leave 0 to use up what ever is on board.</small></li><li><p align=\"left\"><small>Use Treasury. Will make 2mil withdrawals and put remainder<br>back after Furb. Script will spend all avail cash, so be careful.</small></li><li><p align=\"left\"><small>Script might be a little noisy for </small><small>Corpies so you can turn off<br>" +
				"output or redirect to Swath Console</small></li><li><p align=\"left\"><small>Buy Gen Torps/Atomics. It's not easy to code what these<br>values should be, default to 20; perhaps using whatever's<br>on hand might be a start --we'll see. Make sure you know<br>you ships max values ahead of time.</small></li></ol>\n\n" +
				"<p align=\"left\"><small><b>A few words about the script:</b></small></p><ol><li><p align=\"left\"><small>Will run continuously until Planet is completely full, or you<br>run out of cash;</small></li><li><p align=\"left\"><small>Before a furb-macro is initiated it will verify a few things:<br>" +
				"Enough Gas on planet to fill holds,<br>Align's over 1k,<br>Minimum creds on hand --1mil,<br>Corp/Per fig is deployed,<br>Is Stardock it still there,<br>and finally macro bursts into Stardock, scrubs, buy Atomics<br>and leaves P.D.Q.</small></li><li><p align=\"left\"><small>Before furb, script will reload off of Planet figs, so stock up.<br>" +
				"Use a ship that can't be done-in with a single attack wave.</small></li><li><p align=\"left\"><small>Script is meant for use in UNLIM games; however, it still<br>reports turns remaining, if any, after it empties a planet. If<br>using in a turn-based game be warned that it doesn't care<br>how many turns you have left (esp when furbing).</small></li>" +
				"</ol>\n\n<p align=\"left\"><small><b>A few Caveats/Tips:</b></small></p><ol><li><p align=\"left\"><small>My disclaimer: If this script causes you to fuse, or anything<br>negative please let me know and I'll try to fix the script;</small></li><li><p align=\"left\"><small>If you want to farm a little bit at a time, put only a few Gen-trop/Atomics<br>" +
				"on board and turn furbing off;</small></li><li><p align=\"left\"><small>Overload the sector with planets, alot. This usually<br>spawns/creates the desirable planets often;</small></li><li><p align=\"left\"><small>If on a mixed Corp, and using a Fed ship that requires a level of<br>EXP, be sure to stop and xport to another ship. The script will<br>" +
				"not check the time --maybe a future version will;</small></li><li><p align=\"left\"><small>If you Pod for any reason, the script wont detect it. Be warned;</small></li><li><p align=\"left\"><small>Script will run until one of the following conditions is met: All<br>Product categories are filled, or you run out of cash, or you run<br>" +
				"out of Shields &amp; Figs;</small></li><li><p align=\"left\"><small>Another xTern caveat, if you're not concerned with EXP penalties<br>then be mindful that planets could collide with you on one of them;</small></li><li><p align=\"left\"><small>On occasion, Swath sticks or stalls and it appears that nothing is<br>happening. A possible remedy is to type <b>^M</b> into the 'TW Console'<br>" +
				"in the same you might send it over SS/Fed;</small></li><li><p align=\"left\"><small>For some reason, chatter casues script to stall, see #8 for possible<br>fix, you can also turn msg's off to </small><small>alleviate</small><small>this bug.</small></li><li><p align=\"left\"><small>Lastly, there are many options that could be built in, some obvious<br>some not so obvious. Drop me a line and I'll incorporate them in the<br>the next version: Team-TerraFARMa.</small></li></ol>\n\n<p align=\"left\"><small><a href=\"mailto:myoptik@yahoo.com\"><b><i>LoneStar</i></b></a></small></p></blockquote>"; }         

		public boolean initScript() throws Exception {
			if(!Swath.main.isHelperMode()) {
				throw new ScriptException("Helper Mode Not On. Light Bulb must be on to use this script."); }
			if(Swath.sector.fighters() <= 0 || !(Swath.sector.ftrOwner().isYou() || Swath.sector.ftrOwner().isYourCorporation())){
				throw new ScriptException("You must place fighters in the starting sector.");}
			if(Swath.ship.transWarpDrive() == Ship.NO_TWD){
				throw new ScriptException("Ship MUST have transwarp drive..");	}
			if(Swath.ship.holds() == 0) {
				throw new ScriptException("Your ship doesn't appear to have any Holds.");	}
			if((Swath.ship.shields() == 0) && (Swath.ship.fighters() == 0) ) {
				throw new ScriptException("You must have some level of Shields and or Fighters to use this script");}

			planets = Swath.getAllPlanetClasses();

			if (atPrompt(Swath.PLANET_PROMPT)) {
				Basket = Swath.getPlanet(Swath.main.currPlanet());
			} else {
				throw new ScriptException("Not at correct prompt. Must start from Command or Planet prompt.");
			}
			if (Swath.you.alignment() >= 1000) {
				furbsector = new Parameter("Star Dock (0 = No Refurb)");
				furbsector.setType(Parameter.INTEGER);
				furbsector.setIntegerRange(0, Swath.main.sectors());
				furbsector.setInteger(Swath.main.stardock());
				registerParam(furbsector);
			}
			treasury = new Parameter("Use All of Treasurey?");
			treasury.setType(Parameter.BOOLEAN);
			registerParam(treasury);
			output = new Parameter("Output To");
			output.setType(Parameter.CHOICE);
			output.addChoice(0, "Swath Console");
			output.addChoice(1, "SubSpace Radio");
			output.addChoice(2, "None");
			output.setCurrentChoice(1);
			registerParam(output);
			verbose = new Parameter("Verbose Output?");
			verbose.setType(Parameter.BOOLEAN);
			registerParam(verbose);
			buyTorps = new Parameter("Buy How Many Torpedoes");
			buyTorps.setType(Parameter.INTEGER);
			buyTorps.setIntegerRange(1, 20);
			buyTorps.setInteger(20);
			registerParam(buyTorps);
			buyAtomics = new Parameter("Buy How Many Detonators");
			buyAtomics.setType(Parameter.INTEGER);
			buyAtomics.setIntegerRange(1, 20);
			buyAtomics.setInteger(20);
			registerParam(buyAtomics);
			owner = Swath.PERSONAL;
			return true;
	}

	public boolean runScript() throws Exception {
		boolean NoFurb = true;
		int pidAmounts[];
		int i = 0;
		
		if(Swath.you.alignment() >= 1000) {
			furb = furbsector.getInteger();
		} else {
			output(" **** Furb not avail, continuing anyways.");
		}

		if (furb > 0) { NoFurb = false; }
		
		LiftOff.exec();
		JettisonCargo.exec();
		Land.exec(Basket);		
		EnterCitadel.exec();
		DisplayCurrentInfo.exec(false);
		EnterComputer.exec();

		ChangeSettings.exec(ChangeSettings.SPACE);	// MD's userdfined routine
		while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
		SendString.exec(";");
		while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
		LeaveComputer.exec();
		while (Swath.main.prompt() != Swath.CITADEL_PROMPT) { Thread.sleep(50); }
		LeaveCitadel.exec();

		BAmounts = Basket.productAmounts();			// get Planet product amounts
		getMaxAmounts();						// set Prdouct amount(s) vars
		LiftOff.exec();

		output(" --[ LoneStars TerraFARMa "+Ver+" ]---- Filling Planet: "+Basket.name()+" #"+Basket.id());
		if (!verbose.getBoolean()){ output("  --[   Running In Quiet Mode      ]----");}

		while (Swath.ship.shields() > 500 || Swath.ship.fighters() > 1000) {
			while ((Swath.ship.atomicDevices() > 0)&& (Swath.ship.genesisTorpedos() > 0 )) {
				if ((Fonhand >= FMax) && (Oonhand >= OMax) && (Eonhand >= EMax)) {
					if (verbose.getBoolean()){ output(" --[ Planet's Completely Full ]----  Please sir, may I have another...");}
					throw new ScriptException("Planet is Full Nothing To Do");	}

				JettisonCargo.exec();
				DisplaySector.exec();
				
				if (!(FastCreateandLand.exec(PName, Swath.CORPORATE))) {
					throw new ScriptException("Unable to create and land."); 	}

				ToEmpty = Swath.getPlanet(Swath.main.currPlanet());
				pidAmounts = ToEmpty.productAmounts();

				if (verbose.getBoolean()){ 
					if (verbose.getBoolean()){ output("[][] "+ToEmpty.className()+" "+ToEmpty.type()+" [F/O/E]: "+NumberFormat.getInstance().format(pidAmounts[Swath.FUEL_ORE])+" / "+NumberFormat.getInstance().format(pidAmounts[Swath.ORGANICS])+" / "+NumberFormat.getInstance().format(pidAmounts[Swath.EQUIPMENT])); }
				}

				if ((pidAmounts[Swath.FUEL_ORE] > 0) || (pidAmounts[Swath.ORGANICS] > 0) || (pidAmounts[Swath.EQUIPMENT] > 0)) {
					if (pidAmounts[Swath.FUEL_ORE] > 0) {
						if (Fonhand < FMax) {
							if (verbose.getBoolean()){ output("+--moving FUEL ORE"); }
							i = (FMax - Fonhand);
							if (pidAmounts[Swath.FUEL_ORE] <= i) {  i = pidAmounts[Swath.FUEL_ORE];	}
							Mover(Swath.FUEL_ORE, i);
							Fonhand = Fonhand + i;				// Add amount moved
							FTot = FTot + i;					// Running Total
						} else {
							if (verbose.getBoolean()){ output("+--Planet FUEL ORE is Full");}
							if (Swath.ship.fuel() > 0) {
								LiftOff.exec();
								JettisonCargo.exec();
								Land.exec(ToEmpty);
							}
						}
					}
					if (pidAmounts[Swath.ORGANICS] > 0) {
						if (Oonhand < OMax) {
							if (verbose.getBoolean()){ output("+--moving ORGANICS"); }
							i = (OMax - Oonhand);
							if (pidAmounts[Swath.ORGANICS] <= i) {  i = pidAmounts[Swath.ORGANICS];	}
							Mover(Swath.ORGANICS, i);
							Oonhand = Oonhand + i;				// Add amount moved
							OTot = OTot + i;					// Running Total
						} else {
							if (verbose.getBoolean()){ output("+--Planet ORGANICS is Full");}
							if (Swath.ship.organics() > 0) {
								LiftOff.exec();
								JettisonCargo.exec();
								Land.exec(ToEmpty);
							}
						}
					}
					if (pidAmounts[Swath.EQUIPMENT] > 0) {
						if (Eonhand < EMax) {
							if (verbose.getBoolean()){ output("+--moving EQUIPMENT");}
							i = (EMax - Eonhand);
							if (pidAmounts[Swath.EQUIPMENT] <= i) {  i = pidAmounts[Swath.EQUIPMENT];	}
							Mover(Swath.EQUIPMENT, i);
							Eonhand = Eonhand + i;				// Add amount moved
							ETot = ETot + i;					// Running Total
						} else {
							if (verbose.getBoolean()){ output("+--Planet EQUIPMENT is Full");}
							if (Swath.ship.equipment() > 0) {
								LiftOff.exec();
								JettisonCargo.exec();
								Land.exec(ToEmpty);
							}
						}
					}

					if (verbose.getBoolean()){ output("--Farmed--+--ORE: "+NumberFormat.getInstance().format(FTot)+"---+---ORG: "+NumberFormat.getInstance().format(OTot)+"--+--EQU: "+NumberFormat.getInstance().format(ETot)+"---");}
				}

				if ((Swath.ship.atomicDevices() == 1) && (Swath.ship.genesisTorpedos() == 0) && (!NoFurb)) {
					LiftOff.exec();
					Land.exec(Basket);
					LiftOff.exec();	
					BAmounts = Basket.productAmounts();			// get Planet product amounts
					getMaxAmounts();
					output(" --[  Farmed   ]--+--ORE: "+NumberFormat.getInstance().format(FTot)+"--+--ORG: "+NumberFormat.getInstance().format(OTot)+"--+--EQU: "+NumberFormat.getInstance().format(ETot)+"---"); 
					output(" --[ On Planet ]--+--ORE: "+NumberFormat.getInstance().format(Fonhand)+"--+--ORG: "+NumberFormat.getInstance().format(Oonhand)+"--+--EQU: "+NumberFormat.getInstance().format(Eonhand)+"---"); 
					Refurb();
					if ((Swath.ship.atomicDevices() < buyAtomics.getInteger()) || (Swath.ship.genesisTorpedos() < buyTorps.getInteger())) {
						output(" *** Unable to purchase full amounts of Torpedoes and Detonators ***");
						NoFurb = true;
					}
					Land.exec(ToEmpty);
				}

				SendString.exec("Z  D  Y  /");
				while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(100); }

				if (verbose.getBoolean()){ 
					String strn = "";
					if (Swath.you.turns() == 65535) {
						strn = "UNLIM";
					} else {
						strn = ""+Swath.you.turns()+"";
					}
					output("Turns "+strn+" [] Atomics "+Swath.ship.atomicDevices()+" [] Torps "+Swath.ship.genesisTorpedos()+" [] Shields "+Swath.ship.shields()+" [] Figs "+Swath.ship.fighters());
				}
			}

			if (!NoFurb) {
				BAmounts = Basket.productAmounts();			// get Planet product amounts
				getMaxAmounts();
				output(" --[  Farmed   ]--+--ORE: "+NumberFormat.getInstance().format(FTot)+"--+--ORG: "+NumberFormat.getInstance().format(OTot)+"--+--EQU: "+NumberFormat.getInstance().format(ETot)+"---"); 
				output(" --[ On Planet ]--+--ORE: "+NumberFormat.getInstance().format(Fonhand)+"--+--ORG: "+NumberFormat.getInstance().format(Oonhand)+"--+--EQU: "+NumberFormat.getInstance().format(Eonhand)+"---"); 
				Refurb();
				if ((Swath.ship.atomicDevices() < buyAtomics.getInteger()) || (Swath.ship.genesisTorpedos() < buyTorps.getInteger())) {
					output(" *** Unable to purchase full amounts of Torpedoes and Detonators ***");
					NoFurb = true;
				}
			} else { break; }
		}
		output(" --[ LoneStars TerraFARMa "+Ver+" ]---- Completed Finished filling #"+Basket.id());
		return true;
	}

	public void Refurb() throws Exception {
		int buyAtom = 0;
		int buyTorp = 0;
		int iwarp = 0;
		int fcount = 0;			// Figs count. to determine SD attacks
		int sCount = 0;			// Shields info.

		if(Basket.productAmounts()[Swath.FUEL_ORE] < Swath.ship.holds()) {
			output("Not enough fuel on planet to refurb with");
			throw new ScriptException("Not Enough Fuel On Planet..");
		}
		if(Swath.you.alignment() < 1000) {
			output("Must be a Commished Blue to use this script to furb");
			throw new ScriptException("Manual Furb Please..");
		}
		output("--------[FURBING]----------");
		WhosPlaying();

		JettisonCargo.exec();
		Land.exec(Basket);
		
		SendMacro.exec("T  N  T  1 ^M  M  N  T  ^M  ^M  ",1,false);

		while (Swath.main.prompt() != Swath.PLANET_PROMPT) { Thread.sleep(100); }

		if (treasury.getBoolean()) {
			EnterCitadel.exec();
			TakeLeaveCredits.exec(2000000);
			LeaveCitadel.exec();
		}

		LiftOff.exec();
		DisplayCurrentInfo.exec(true);

		if((Swath.you.credits() > CredLimit)){
			if (Swath.ship.atomicDevices() < buyAtomics.getInteger()) {
				buyAtom = buyAtomics.getInteger()- Swath.ship.atomicDevices();
			} else {
				buyAtom = 0;		}
			if (Swath.ship.genesisTorpedos() < buyTorps.getInteger()) {
				buyTorp = Swath.ship.genesisTorpedos() - buyTorps.getInteger();
			} else {
				buyTorp = 0;		}

			DisplaySector.exec();
			if(Swath.sector.fighters() <= 0 || !(Swath.sector.ftrOwner().isYou() || Swath.sector.ftrOwner().isYourCorporation())){
				output("Cannot Furb: Sector Fig Not Present");
				throw new ScriptException("Sector Fig not Present, cannot Furb.");
			}
			EnterComputer.exec();
			PortReport.exec(furb);
			LeaveComputer.exec();

			Sector tempsector = Swath.getSector(furb);
			
			if ((tempsector.portStatus() != Sector.PORT_AVAILABLE) || (tempsector.portStatus() == Sector.PORT_DESTROYED)) {
				output("Stardock Appears to have been Blown-Up");
				throw new ScriptException("Stardock does not appear to exist.");
			}

			fcount = Swath.ship.fighters();
			output("Macro Furbing...");
			SendMacro.exec("m "+furb+" ^M Y Y ^M P S Y H A "+buyAtom+"^M T "+buyTorp+"^M Q Q "+Basket.sector()+"^M Y Y ^M ");
			output("...Macro Complete.");

			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(50); }
			JettisonCargo.exec();
			DisplayCurrentInfo.exec(true);
			
			fcount = fcount - Swath.ship.fighters();
			
			if (fcount != 0) {
				output(" --[ Dock Killa Detected ]---- "+NumberFormat.getInstance().format(fcount)+" Figs Killed while Furbing.");
			}

			if (treasury.getBoolean()) {	
				Land.exec(Basket);
				EnterCitadel.exec();
				TakeLeaveCredits.exec((Swath.you.credits() * -1));
				output("  --[ Citadel Cash Used ]----  "+NumberFormat.getCurrencyInstance().format(Basket.treasury())+", remain.");
				LeaveCitadel.exec();
				LiftOff.exec();
			}
		} else {
			output(" --[ Cannot Furb ]---- Not enough cash.");
			throw new ScriptException("Cannot Furb. Not enough cash on hand.");
		}
	}

	public void Mover(int Prod, int HowMuch) throws Exception {
		int holds = Swath.ship.holds();		// Ships Holds
		int Carry = 0;						// what we're taking in a trip
		int foe = 0;
		int amnt = 0;						// total amount
		int iter = 0;
		int legs = 0;
		int last = 0;
		int t = 0;

		amnt = HowMuch;

		switch (Prod) {
			case Swath.FUEL_ORE:
				foe = 1;
				break;
			case Swath.ORGANICS:
				foe = 2;
				break;
			case Swath.EQUIPMENT:
				foe = 3;
				break;
			default:
				output("Attempted to Move non-existant product, contact your service dealer");
				throw new ScriptException("Unkown Product. Not known FOE");
		}

		iter = amnt / holds;			// Number of Macro cycles
		t = (iter * holds);

		if (t < amnt) {					// Round about way of getting remainder
			last = amnt-t;				// 10,000 / 255holds=39.215
		}								// last = 10,000 - (39*255) = 9945
										// last = 55
		if (iter > 100) {				// do the job in legs
			while (iter > 0) {			//
				if (iter > 100) {		// if iter is still > 100
					legs = 100;			// do another 100 cycle leg
					iter = iter-100;	//
				} else {				// else do what ever remains
					legs = iter;
					iter = 0;
				}
				// Thanks to Singularity's Macro Tutorial for 'Z' buffering of possible 'missing' planet.
				//SendMacro.exec("T N T "+foe+holds+"^M Q L "+Basket.id()+"^M T N L "+foe+"^M Q L "+ToEmpty.id()+"^M ",legs,false);
				SendMacro.exec("T N J T "+foe+" "+holds+" ^M Q Q Z N L "+Basket.id()+" ^M N N ^M J T N J L "+foe+" ^M Q Q Q Z N L "+ToEmpty.id()+" ^M ",legs,false);
			}
		} else {							// there isn't more than 100 cycles
			//SendMacro.exec("T N T "+foe+holds+"^M Q L "+Basket.id()+"^M T N L "+foe+"^M Q L "+ToEmpty.id()+"^M ",iter,false);
			SendMacro.exec("T N J T "+foe+" "+holds+" ^M Q Q Z N L "+Basket.id()+" ^M N N ^M J T N J L "+foe+" ^M Q Q Q Z N L "+ToEmpty.id()+" ^M ",iter,false);

		}

		if (last > 0) {						// get last little bit
			//SendMacro.exec("T N T "+foe+last+"^M Q L "+Basket.id()+"^M T N L "+foe+"^M Q L "+ToEmpty.id()+"^M ",1,false);
			SendMacro.exec("T N J T "+foe+last+" ^M Q Q Z N L "+Basket.id()+" ^M N N ^M J T N J L "+foe+" ^M Q Q Q Z N L "+ToEmpty.id()+" ^M ",1,false);

		}
	}

	public void getMaxAmounts() throws Exception {
		if (planets.length > 0) {
			for (int i = 0; i < planets.length; i++) {
				if (planets[i].name().equals(Basket.className())) {
					MaxAmounts = planets[i].maxAmounts();
					FMax = MaxAmounts[Swath.FUEL_ORE];
					OMax = MaxAmounts[Swath.ORGANICS];
					EMax = MaxAmounts[Swath.EQUIPMENT];
					Fonhand = BAmounts[Swath.FUEL_ORE];
					Oonhand = BAmounts[Swath.ORGANICS];
					Eonhand = BAmounts[Swath.EQUIPMENT];
				}
			}
		} else {
			String s = " *** Unable to obtain Maximum Planet Product Amounts ***";
			output(s);
			throw new ScriptException(s);
		}
	}
	public void WhosPlaying() throws Exception {
		Trader[] w; 
		String s = "Who's Playing: ";

		w = ShowWhoIsPlaying.exec();
		
		if (w.length > 0) {
			for (int i = 0; i < w.length; i++) {
				s = s + w[i].name() + ", ";
			}
		} else { s = s+"No one."; }
		output(s);
	}
	public void output(String message) throws Exception {
		String m = message;
		if (output.getCurrentChoice() == 0) {
			UserAlert.exec(m, UserAlert.TYPE_INFORMATION);
		} else if (output.getCurrentChoice() == 1) {
			SendSSRadioMessage.exec(m);
		} else {
			// Do nothing
		}
	}
}