import com.swath.*;
import com.swath.cmd.*;
/*
	Create and land on a planet
*/

public class FastCreateandLand extends UserDefinedCommand {
	private String name;
	private int owner;	
	private boolean isDone;

	public String getName() {
		return "Create and Land on a planet";
	}

	public boolean initCommand() throws Exception {
		if(!atPrompt(Swath.COMMAND_PROMPT)){
			throw new Exception("Must be at Command Prompt.");
		}
		return true;
	}

	public void startCommand() throws Exception {
		sendString("uy");
	}

	public void endCommand(boolean finished) throws Exception {
		setResult(new Boolean(isDone));
	}

	public void onText(String buffer, String text) throws Exception {
		Tools.TextRange range;

		if ((range = ((Tools.findText(buffer, "What do you want to name this planet? (",")")))) != null) {
//			String input = Tools.getText(buffer, range);
//			input = input.substring(input.indexOf("("), input.lastIndexOf(")"));
			sendString(name+RETURN_KEY);

			if (owner == Swath.PERSONAL) {
				sendString("p");
			} else {
				if(Swath.you.corporation() != null) {
					sendString("c");
				} else {
					sendString("p");
				}
			}
			setBufferText("");
			sendString("L");
			isDone=false;
		}
		else if((range = ((Tools.findText(buffer, "WARNING! It is potentially hazardous to place more than","Do you wish to abort?")))) != null) {
			setBufferText("");
			sendString("n");
		}
		else if ((range = ((Tools.findText(buffer, "<Atmospheric maneuvering system engaged>","Land on which planet <Q to abort>")))) != null) {
			String input = Tools.getText(buffer,range);
			int loc;
			if((loc = input.indexOf(name)) < 0){
				throw new CommandException(this,"Invalid Planet");
			}
			else{
				input = input.substring(loc-8,loc).trim();
				input = input.substring(input.indexOf("<")+1,input.indexOf(">")).trim();
			}
			sendString(input+RETURN_KEY);
			setBufferText("");
			isDone=true;
		}
		else if(((range = ((Tools.findText(buffer, "<Atmospheric maneuvering system engaged>","Landing sequence engaged...")))) != null)){
			setBufferText("");
			isDone=true;
		}
	}

	public void onEvent(EventIfc event) throws Exception {
//		// Here you can receive and process incoming events
//		printTrace("onEvent('" + event.getClassName() + "')");
	}

	public static boolean exec(String name, int owner) throws Exception {
				
		FastCreateandLand cmd = new FastCreateandLand();
		cmd.initInstance();
		cmd.name = name;
		cmd.owner = owner;
		return ((Boolean) (cmd.execInstance())).booleanValue();
	}
}
