import com.swath.*;
import com.swath.cmd.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class Deadend extends UserDefinedScript {
	private int sec;
	protected Parameter IncDecRnd;	// Incremental/Decrimental/Random
	protected Parameter Results;		// Maximum result to return
	protected Parameter UpdateCIM;	//
	protected Parameter FName;		// Name of output file
	
	public String getName() {		return "UnFigged Deadends"; }
	public String getDescription() {	return "Search for Deadends that have no Figther(s) deployed.\n\n "+
					"You should update your Fighter deployment before beginning. This script "+
					"is intended to work with Rammers Twarp Gridder V1.95 --for TWX Proxy.\n\n"+
					"Outputs a text file listing result sectors. ZTM is not required, but is advisable."; }

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.COMMAND_PROMPT)) {
			throw new ScriptException("Not at correct prompt");	
		}

		FName = new Parameter("Filename");
		FName.setType(Parameter.STRING);
		FName.setMaxStringLength(20);
		FName.setString("c://DND");
		registerParam(FName);

		IncDecRnd = new Parameter("Search Method");
		IncDecRnd.setType(Parameter.CHOICE);
		IncDecRnd.addChoice(1, "Incremental");
		IncDecRnd.addChoice(2, "Decremental");
		IncDecRnd.addChoice(3, "Random");
		IncDecRnd.setCurrentChoice(1);
		registerParam(IncDecRnd);

		Results = new Parameter("Result Limit");
		Results.setType(Parameter.INTEGER);
		Results.setIntegerRange(1, Swath.main.sectors());
		Results.setInteger(100);
		registerParam(Results);

		UpdateCIM = new Parameter("Update CIM");
		UpdateCIM.setType(Parameter.BOOLEAN);
		UpdateCIM.setBoolean(false);
		registerParam(UpdateCIM);
		return true;
	}	
	
	public boolean runScript() throws Exception {
		String str;
		boolean notFin = true;
		int i = 10;
		int ii= 0;
		int iii= 0;				// for random mode

		str = FName.getString();

		if (str == "") {
			str = "c://"+Swath.main.gameName()+"_DND.txt";
		}

		BufferedWriter ug;

		sec = Swath.main.sectors();

		Random r = new Random();

		ug = new BufferedWriter(new FileWriter(str));

		if (UpdateCIM.getBoolean()) {			
			EnterComputer.exec();			// Version of TW prior to 2.3 require 
			CIMDownload.exec(true, false);		// entering the computer
			LeaveComputer.exec();
		}

		if (IncDecRnd.getCurrentChoice() == 2) { i = Swath.main.sectors() + 1; }

		while (notFin) {
			switch(IncDecRnd.getCurrentChoice()) {		// Sector incrementor
				case 1:				// Incremental
					i++;
					if (i > Swath.main.sectors()) { notFin = false; }
					break;
				case 2:				// Decrimental
					i--;
					if (i < 11) {notFin = false; }
					break;
				case 3:				// Random
					iii++;
					i = r.nextInt(Swath.main.sectors());
					if (iii > Swath.main.sectors()) {notFin = false; }
					break;
				default:
					break;
			}

			Sector s = Swath.getSector(i);
			
			if ((s.warps() == 1) && (!s.isAvoided())) {
				if ((s.fighters() == 0) || (!(s.ftrOwner().isYou())) && (!(s.ftrOwner().isYourCorporation()))) {			
					ug.write(String.valueOf(i));
					ug.newLine();

					ii++;					// Result Cycle counter

					if (Results.getInteger() != 0) {
						if (ii > Results.getInteger()) { notFin = false; }
					} else {
						if (ii > Swath.main.sectors()) { notFin = false; }
					}	
				}		
			}
		} 
		ug.close();

		SendSSRadioMessage.exec("LoneStar's Unfig'd Deadend : Found "+ii+" Unfig'd Deadends.");

		return true;
	}

	public void endScript(boolean finished) throws Exception {
		// Nadda to do
	}

}