import com.swath.*;
import com.swath.cmd.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class PTradeList extends UserDefinedScript {
	protected Parameter FName;			// Name of Shopping list file
	protected Parameter output;			// SSpace, Swath console, no ouput
	protected Parameter useplanet;		// Planet selection
	private int[] sectorList;			// Array of sectors to PTrade
	private Planet[] peas;			// Array of planets in current sector
	private Planet curPlanet;			// 
	private int[] PAmounts;			// Planet Amount Levels
	private Sector Home;			// Starting sector, to return too.
	private int sCreds = 0;
	private int oCreds = 0;			// Moeny used to buy ore

	public String getName() {		return "Planet Trade List"; }
	public String getDescription() {	return "Planetary Trade by List"; }

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.COMMAND_PROMPT)) {
			throw new ScriptException("Not at correct prompt.");	
		}

		peas = Swath.sector.planets();
		useplanet = new Parameter("Use Planet");
		useplanet.setType(Parameter.CHOICE);
		for (int i = 0; i < peas.length; i++) {
			useplanet.addChoice(i, peas[i].toString());
		}
		useplanet.setCurrentChoice(0);
		registerParam(useplanet);

		FName = new Parameter("Filename");
		FName.setType(Parameter.STRING);
		FName.setMaxStringLength(25);
		FName.setString("c://PTrade.txt");
		registerParam(FName);

		output = new Parameter("Output To");
		output.setType(Parameter.CHOICE);
		output.addChoice(0, "Swath Console");
		output.addChoice(1, "SubSpace Radio");
		output.addChoice(2, "None");
		output.setCurrentChoice(0);
		registerParam(output);

		sectorList = new int[100];
		Arrays.fill(sectorList, 0);
		return true;
	}	
	
	public boolean runScript() throws Exception {
		int i = 0;

		curPlanet = (Planet) (peas[useplanet.getCurrentChoice()]);
		Home = Swath.getSector(Swath.sector.sector());

		DisplayCurrentInfo.exec();

		sCreds = Swath.you.credits();

		Land.exec(curPlanet);
		LiftOff.exec();

		if (curPlanet.level() < 4) { throw new ScriptException("Planet must be at least Level 4"); }
	
		PAmounts = curPlanet.productAmounts();
	
		if ((PAmounts[Swath.FUEL_ORE] < 10000) &&  (PAmounts[Swath.EQUIPMENT] < 1000 )) {
			throw new ScriptException("Not enough Product. Planet must have at least: 10,000 units of FUEL ORE and 1,000 units of Equipment");
		}

		output("Reading in File List...");
		
		if (ReadShoppingList()) {
			while (sectorList[i] != 0) {
				Land.exec(curPlanet);

				EnterCitadel.exec();

				try { 
					PlanetWarp.exec(sectorList[i]);
				}
				catch (Exception e) {
					output("Unable to PWarp to Sector : "+sectorList[i] );
				}
				
				LeaveCitadel.exec();
				LiftOff.exec();
				DisplaySector.exec();

				if (sectorList[i] == Swath.sector.sector()) {
					DoPTrade();
				}

				if (PAmounts[Swath.EQUIPMENT] < 1000 ) {
					output("Out of Product, returning Home...");
					sectorList[i] = 0;
				} else {
					i++;
				}
			}

			if (sectorList[i] != Home.sector()) {
				Land.exec(curPlanet);
				EnterCitadel.exec();

				try {
					PlanetWarp.exec(Home);
				}
				catch (Exception e) {
					output("Unable to return Home - Sector "+Home.sector()+".");
				}
			}

			LeaveCitadel.exec();
			DisplayCurrentInfo.exec(true);

			if (sCreds < Swath.you.credits()) {
				output("Profit Total after "+i+" Planetary Tades : "+NumberFormat.getCurrencyInstance().format(Swath.you.credits()-sCreds));
			}
		}
		return true;
	}

	private void DoPTrade() throws Exception {
		int i = 0;
		int c = 0;
		String s = "";

		EnterComputer.exec();
		PortReport.exec(Swath.sector);
		LeaveComputer.exec();

		if (Swath.sector.portStatus() == Sector.PORT_AVAILABLE) {
			c = Swath.you.credits();
			PlanetaryTrade.exec(curPlanet,0,(Swath.sector.portAmounts()[Swath.ORGANICS]), (Swath.sector.portAmounts()[Swath.EQUIPMENT]));
			curPlanet = Swath.getPlanet(curPlanet.id());
			PAmounts = curPlanet.productAmounts();

			DisplayCurrentInfo.exec(true);

			output("Planetary Trade Profit Report : Sector "+Swath.sector.sector()+"  :   "+NumberFormat.getCurrencyInstance().format(Swath.you.credits() - c));

			if (PAmounts[Swath.FUEL_ORE] < 200000){
				DisplaySector.exec();
				EnterComputer.exec();
				PortReport.exec(Swath.sector.sector());
				LeaveComputer.exec();

				if ((Swath.sector.portAmounts()[Swath.FUEL_ORE] > 3000) && (Swath.sector.portInfo()[Swath.FUEL_ORE] == Sector.SELLING) && (Swath.ship.holds() > 0)) {
					JettisonCargo.exec();	

					i = (Swath.sector.portAmounts()[Swath.FUEL_ORE] / 2) / Swath.ship.holds();
					oCreds = Swath.you.credits();

					SendMacro.exec("P^M"+Swath.ship.holds()+"^M^ML"+curPlanet.id()+"^MTNL1"+Swath.ship.holds()+"^MQ", i, true);
					while (Swath.main.prompt() != Swath.COMMAND_PROMPT) {
						Thread.sleep(100);
					}
					EnterComputer.exec();			//Macros don't always turn ALL KEYS off
					ChangeSettings.exec(ChangeSettings.SPACE);	// MD's userdfined routine
					LeaveComputer.exec();
					output("Bought Fuel - "+(i * Swath.ship.holds())+" Units for "+NumberFormat.getCurrencyInstance().format(oCreds-Swath.you.credits()));
				}
			}
		}
		DisplaySector.exec();
	}

	public boolean ReadShoppingList() throws Exception {
		BufferedReader targetList;
		String filename = "";
		String line = "";
		int currentline = 0;

		filename = FName.getString();

		try { targetList = new BufferedReader(new FileReader(filename)); } 
		catch (FileNotFoundException e) {
			MessageBox.exec("Target file does not exist.", "Script Error", MessageBox.ICON_ERROR, MessageBox.TYPE_OK);
			return false;
		} catch (IOException e) {
			MessageBox.exec("Error opening file.", "Script Error", MessageBox.ICON_ERROR, MessageBox.TYPE_OK);
			return false;
		}		

		while (targetList.ready()) {
			try { line = targetList.readLine(); }
			catch (IOException e) {
				MessageBox.exec("Error reading from target list.", "Script Error", MessageBox.ICON_ERROR, MessageBox.TYPE_OK);
				return false;	
			}

			line = line.trim();

			try { sectorList[currentline] = Integer.parseInt(line); }
			catch(NumberFormatException e) { return false; }

			currentline++;			
		}

                        return true;
                }

	private void output(String message) throws Exception {
		String m = message;

		if (output.getCurrentChoice() == 0) {
			UserAlert.exec(m, UserAlert.TYPE_INFORMATION);		
		} else if (output.getCurrentChoice() == 1) {
			SendSSRadioMessage.exec(m);
		} else {
			// Do nothing
		}
	}
	public void endScript(boolean finished) throws Exception {
		// Nadda to do
	}

}