import com.swath.*;
import com.swath.cmd.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class Deadend extends UserDefinedScript {
	private int sec;
	private int[] sectlist;			// 
	protected Parameter IncDecRnd;	// Incremental/Decrimental/Random
	protected Parameter Results;		// Maximum result to return
	protected Parameter UpdateCIM;	//
	protected Parameter FName;		// Name of output file
	protected Parameter UpdateFIGS;	//
	protected Parameter SDFilter;		// Just in case someone TEdits SD as a DE
							// ...stop laughing, it could happen ;)
	
	public String getName() {		return "UnFigged Deadends"; }
	public String getDescription() {	return "Search for Deadends that have no Figther(s) deployed.\n\n "+
					"You should update your Fighter deployment before beginning. This script "+
					"is intended to work with Rammers Twarp Gridder V1.95 --for TWX Proxy.\n\n"+
					"Outputs a text file listing result sectors. ZTM is not required, but is advisable.\n\n"+ 
					"Word of caution. If using output with Rammers Twarp gridder, besure to remove the "+
					"blank line at the end of the Text file.\n\nAlso. Script filters any Dead Ends marked "+
					" as Voided.";}

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.COMMAND_PROMPT)) {
			throw new ScriptException("Not at correct prompt");	
		}

		FName = new Parameter("Filename");
		FName.setType(Parameter.STRING);
		FName.setMaxStringLength(20);
		FName.setString("c:\\DEND.txt");
		registerParam(FName);

		IncDecRnd = new Parameter("Search Method");
		IncDecRnd.setType(Parameter.CHOICE);
		IncDecRnd.addChoice(1, "Incremental");
		IncDecRnd.addChoice(2, "Decremental");
		IncDecRnd.addChoice(3, "Random");
		IncDecRnd.setCurrentChoice(3);
		registerParam(IncDecRnd);

		Results = new Parameter("Result Limit");
		Results.setType(Parameter.INTEGER);
		Results.setIntegerRange(1, Swath.main.sectors());
		Results.setInteger(100);
		registerParam(Results);

		UpdateCIM = new Parameter("Update CIM");
		UpdateCIM.setType(Parameter.BOOLEAN);
		UpdateCIM.setBoolean(false);
		registerParam(UpdateCIM);

		UpdateFIGS =  new Parameter("Update Fig List");
		UpdateFIGS.setType(Parameter.BOOLEAN);
		UpdateFIGS.setBoolean(false);
		registerParam(UpdateFIGS);

		SDFilter = new Parameter("Star Dock Filter");
		SDFilter.setType(Parameter.INTEGER);
		SDFilter.setIntegerRange(0, Swath.main.sectors());
		SDFilter.setInteger(Swath.main.stardock());
		registerParam(SDFilter);		

		Arrays.fill(sectorlist, 0);
		return true;
	}	
	
	public boolean runScript() throws Exception {
		String str;
		int i = 11;
		int ptr = 0;
		int DEcount = 0;

		str = FName.getString();
		if (str == "") {
			str = "c:\\DEND.txt";
		}
		f (SDFilter.getInteger == 0) {
			SendSSRadioMessage.exec("LoneStar's Unfig'd Deadend : Not Filtering StarDock");
		}	
		BufferedWriter ug;
		Random r = new Random();
		ug = new BufferedWriter(new FileWriter(str));
		if (UpdateCIM.getBoolean()) {			
			EnterComputer.exec();			// Version of TW prior to 2.3 require 
			CIMDownload.exec(true, false);	// entering the computer
			LeaveComputer.exec();
		}
		if (UpdateFIGS.getBoolean()) {
			ShowDeployedFighters.exec();
		}

		SendSSRadioMessage.exec("LoneStar's Unfig'd Deadend : Parsing Dead End Sectors");

		while(i < Swath.main.sectors()) {
			Sector s = Swath.getSector(i);				

			if ((s.warps() == 1) && (!s.isAvoided())) {
				if ((s.fighters() == 0) || (!(s.ftrOwner().isYou())) && (!(s.ftrOwner().isYourCorporation()))) {			
					DEcount += 1;

					sectlist[ptr] = i;
					ptr++;
				}
			}
			i++;
		}

		SendSSRadioMessage.exec("LoneStar's Unfig'd Deadend : Found "+DEcount+");



		while (notFin) {
			switch(IncDecRnd.getCurrentChoice()) {		// Sector incrementor
				case 1:				// Incremental
					i++;
					if (i > Swath.main.sectors()) { notFin = false; }
					break;
				case 2:				// Decrimental
					i--;
					if (i < 11) {notFin = false; }
					break;
				case 3:				// Random
					iii++;
					i = r.nextInt(Swath.main.sectors());
					if (iii > Swath.main.sectors()) {notFin = false; }
					break;
				default:
					break;
			}

			Sector s = Swath.getSector(i);
			
			if ((s.warps() == 1) && (!s.isAvoided())) {
				if ((s.fighters() == 0) || (!(s.ftrOwner().isYou())) && (!(s.ftrOwner().isYourCorporation()))) {			
					ug.write(String.valueOf(i));
					ug.newLine();

					ii++;					// Result Cycle counter

					if (Results.getInteger() != 0) {
						if (ii > Results.getInteger()) { notFin = false; }
					} else {
						if (ii > Swath.main.sectors()) { notFin = false; }
					}	
				}		
			}
		} 
		ug.close();

		SendSSRadioMessage.exec("LoneStar's Unfig'd Deadend : Found "+ii+" Unfig'd Deadends.");

		return true;
	}

	public void endScript(boolean finished) throws Exception {
		// Nadda to do
	}

}