import com.swath.*;
import com.swath.cmd.*;
import java.util.*;
import java.text.*;

public class Harvester22 extends UserDefinedScript {
	protected static final String Ver = " v2.2";
	protected static final int CredLimit = 10000;
	protected String PName = "<<<DRUiDIA>>>";
	private Parameter sPlanets;
	private Parameter refurb;		// Stardock indicator
	private Parameter via;			//Get to SD via
	private int ivia;
	private Parameter output;		// send msg's
	private Parameter ignoreore;		//
	private Parameter buyTorps;		// Number of Torpedos to buy
	private Parameter buyAtomics;		// Number of Detonators to buy
	private Planet Basket;			// Planet we're filling
	private Planet ToEmpty;			// Planet to empty
	private int FMax = 0;			// Maximum product Basket can hold 
	private int OMax = 0;			//
	private int EMax = 0;			//
	private int owner;			// indicates Personal/Corp context
	private PlanetClass[] planets;
	private Planet[] secPlanets;		// Sector Planets
	private int[] MaxAmounts;
	private int[] PAmounts;
	private int FTot=0;
	private int OTot=0;
	private int ETot=0;

	public String getName() {		return "Planet Harvester"+Ver; }
	public String getDescription() {	return "<CENTER><H1>Planet Harvester"+Ver+"</H1></CENTER><P>\n\n"+
			"<font SIZE=\"2\"><blockquote><ol><li>Script will run until you either Run out of Shields & Fighters, or"+
			"Cash on hand;</li><li>It's best to P-Warp your planet to a dead-end sector away from base so you <br>"+
			"don't have NavHaz to deal with;</li><li>Usually it's best to create a few 'buffer' planets in the sector,"+
			"sometimes this <br>yields the best results;</li><li>Obviously, you should be very careful when running "+
			"this script close to <br>when Extern occurs, lest you run the risk of planets colliding --with you on it;</li>"+
			"<li>This script can be started from either the planet surface (that you want to fill), <br> or from orbit;</li>"+
			"<li>If you're Red, be sure to set a jump sector with a fig close to Star Dock;</li><li>Sometimes Swath sticks and nothing happens a "+
			"remedy to this is to type in the<br>'TW console' the <b>^M</b> character and hit enter. </li></ol></blockquote>"+
			"\n\n<p>Please <a href=\"mailto:myoptik@yahoo.com\">email</a> me any bugs, there's bound to be a few!</p></font>"; }

	public boolean initScript() throws Exception {
		if(Swath.sector.fighters() <= 0 || !(Swath.sector.ftrOwner().isYou() || Swath.sector.ftrOwner().isYourCorporation())){
			throw new ScriptException("You must place fighters in the starting sector.");
		}
		if(Swath.ship.transWarpDrive() == Ship.NO_TWD){
			throw new ScriptException("Ship MUST have transwarp drive..");
		}
		if(Swath.ship.holds() == 0) {
			throw new ScriptException("Your ship doesn't appear to have any Holds.");
		}
		if( (Swath.ship.shields() == 0) && (Swath.ship.fighters() == 0) ) {
			throw new ScriptException("You must have some level of Shields and or Fighters to use this script");
		}

		planets = Swath.getAllPlanetClasses();

		if (atPrompt(Swath.PLANET_PROMPT)) { 
			Basket = Swath.getPlanet(Swath.main.currPlanet());
		} else if (atPrompt(Swath.CITADEL_PROMPT)) {
			LeaveCitadel.exec();
			Basket = Swath.getPlanet(Swath.main.currPlanet());
		} else if (atPrompt(Swath.COMMAND_PROMPT)){
			secPlanets = Swath.sector.planets();

			sPlanets = new Parameter("Select Planet");
			if (secPlanets.length == 0) {
				throw new ScriptException("There must be at least one planet in the current sector.");
			}
			sPlanets.setType(Parameter.CHOICE);
			for (int i=0; i < secPlanets.length; i++) {
				sPlanets.addChoice(i, secPlanets[i].toString());
			}
			sPlanets.setCurrentChoice(0);
			registerParam(sPlanets);
		} else {
			throw new ScriptException("Not at correct prompt. Must start from Command or Planet prompt.");
		}

		refurb = new Parameter("Star Dock (0 = No Refurb)");
		refurb.setType(Parameter.INTEGER);
		refurb.setIntegerRange(0, Swath.main.sectors());
		refurb.setInteger(Swath.main.stardock());
		registerParam(refurb);		

		if (Swath.you.alignment() < 1000) {
			via = new Parameter("Get to SD via");
			via.setType(Parameter.INTEGER);
			via.setIntegerRange(11, Swath.main.sectors());
			via.setInteger(0);
			registerParam(via);
		}

		output = new Parameter("Output To");
		output.setType(Parameter.CHOICE);
		output.addChoice(0, "Swath Console");
		output.addChoice(1, "SubSpace Radio");
		output.addChoice(2, "None");
		output.setCurrentChoice(1);
		registerParam(output);

		buyTorps = new Parameter("Buy How Many Torpedoes");
		buyTorps.setType(Parameter.INTEGER);
		buyTorps.setIntegerRange(1, 20);
		buyTorps.setInteger(20);
		registerParam(buyTorps);

		buyAtomics = new Parameter("Buy How Many Detonators");
		buyAtomics.setType(Parameter.INTEGER);
		buyAtomics.setIntegerRange(1, 20);
		buyAtomics.setInteger(20);
		registerParam(buyAtomics);

		ignoreore = new Parameter("Ignore Ore Over 10k");
		ignoreore.setType(Parameter.BOOLEAN);
		ignoreore.setBoolean(false);
		registerParam(ignoreore);

		owner = Swath.PERSONAL;

		return true;
	}	

	
	public boolean runScript() throws Exception {
		boolean NoFurb = true;

		int pidAmounts[];

		if (refurb.getInteger() > 0) { NoFurb = false; }
		if (Swath.you.alignment() < 1000) { ivia = via.getInteger(); }
			
		if (Basket == null) {
			Basket = (Planet) (secPlanets[sPlanets.getCurrentChoice()]); 
		} else {
			LiftOff.exec();
		}
		
		UpdateShipSpec();

		PAmounts = Basket.productAmounts();

		output(" --[ Harvestor"+Ver+" ]---- Sector "+Swath.sector.sector()+", Filling Planet: "+Basket.name()+" #"+Basket.id());
		
		getMaxAmounts();
		
		while (Swath.ship.shields() > 0 && Swath.ship.fighters() > 0) {
			while ((Swath.ship.atomicDevices() > 0)&& (Swath.ship.genesisTorpedos() > 0 )) {
				if (!(FastCreateandLand.exec(PName, Swath.CORPORATE))) {
					throw new ScriptException("Unable to create and land.");
				}

				ToEmpty = Swath.getPlanet(Swath.main.currPlanet());
				pidAmounts = ToEmpty.productAmounts();
				output("[][] "+ToEmpty.className()+" "+ToEmpty.type()+" [F/O/E]: "+NumberFormat.getInstance().format(pidAmounts[Swath.FUEL_ORE])+" / "+NumberFormat.getInstance().format(pidAmounts[Swath.ORGANICS])+" / "+NumberFormat.getInstance().format(pidAmounts[Swath.EQUIPMENT]));

				if ((pidAmounts[Swath.FUEL_ORE] > 0) || (pidAmounts[Swath.ORGANICS] > 0) || (pidAmounts[Swath.EQUIPMENT] > 0)) {
					if (ignoreore.getBoolean() && (pidAmounts[Swath.FUEL_ORE] > 10000)) {
						output(" **** Ignoring Ore Over 10k ****");
					} else {
						if (pidAmounts[Swath.FUEL_ORE] > 0) {
							output("+--moving FUEL ORE");
							Mover(Swath.FUEL_ORE, pidAmounts[Swath.FUEL_ORE]);
							FTot = FTot + pidAmounts[Swath.FUEL_ORE];
							FMax = FMax - pidAmounts[Swath.FUEL_ORE];
						}
					}
					if (pidAmounts[Swath.ORGANICS] > 0) {
						output("+--moving ORGANICS");
						Mover(Swath.ORGANICS, pidAmounts[Swath.ORGANICS]);
						OTot = OTot + pidAmounts[Swath.ORGANICS];
						OMax = OMax - pidAmounts[Swath.ORGANICS];
					}
					if (pidAmounts[Swath.EQUIPMENT] > 0) {
						output("+--moving EQUIPMENT");
						Mover(Swath.EQUIPMENT, pidAmounts[Swath.EQUIPMENT]);
						ETot = ETot + pidAmounts[Swath.EQUIPMENT];
						EMax = EMax - pidAmounts[Swath.EQUIPMENT];
					}
					//output("--Farmed--+--ORE: "+NumberFormat.getInstance().format(FTot)+"---+---ORG: "+NumberFormat.getInstance().format(OTot)+"--+--EQU: "+NumberFormat.getInstance().format(ETot)+"---");
					PlanetStat(Basket);
				}
				SendString.exec("Z D Y /#");
				while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(100); }

				String strn = "";

				if (Swath.you.turns() == 65535) {
					strn = "UNLIM";
				} else {
					strn = ""+Swath.you.turns()+"";
				}
				output("Turns "+strn+" [] Atomics "+Swath.ship.atomicDevices()+" [] Torpedos "+Swath.ship.genesisTorpedos()+" [] Shields "+Swath.ship.shields());
				WhosPlaying();
			}
				
			if (!NoFurb) { 
				Refurb(); 
				getMaxAmounts();
				if ((Swath.ship.atomicDevices() < buyAtomics.getInteger()) || (Swath.ship.genesisTorpedos() < buyTorps.getInteger())) {
					output(" *** Unable to purchase full amounts of Torpedoes and Detonators ***");
					NoFurb = true;
				}
			} else {
				break;
			}
		}	
		return true;
	}

	public void Refurb() throws Exception {
		int buyAtom = 0;
		int buyTorp = 0;
		int iwarp = 0;

		if(Swath.sector.fighters() <= 0 || !(Swath.sector.ftrOwner().isYou() || Swath.sector.ftrOwner().isYourCorporation())){
			throw new ScriptException("You must place fighters that you own in the starting sector..");
		}
		if(Basket.productAmounts()[Swath.FUEL_ORE] < Swath.ship.holds()) {
			output("Not enough fuel on planet to refurb with");
			throw new ScriptException("Not Enough Fuel On Planet..");
		}

		output("--------[REFURBING]----------");

		if(Swath.you.credits() > CredLimit){
			Land.exec(Basket);
			TakeLeaveProducts.exec(Swath.ship.emptyHolds(),0,0);
			LiftOff.exec();

			try {
				if (Swath.you.alignment() > 1000) {
					TransWarp.exec(refurb.getInteger());
				} else {
					TransWarp.exec(ivia);
				}
			}
			catch (Exception e) {
				output("Unable to Refurb. Check Alignment or Jump Sector.");
				throw new ScriptException("Unable to Furb");		
			}

			if (ivia > 0) { Move.exec(refurb.getInteger()); }
		

			if (Swath.sector.sector() != refurb.getInteger()) {
				output("Unable to reach StarDock");
				throw new ScriptException("Unable to to Refurb");
			}

			LandOnStarDock.exec(true);

			if (Swath.ship.atomicDevices() < buyAtomics.getInteger()) {
				buyAtom = buyAtomics.getInteger()- Swath.ship.atomicDevices();
			} else {
				buyAtom = 0;
			}

			if (Swath.ship.genesisTorpedos() < buyTorps.getInteger()) {
				buyTorp = Swath.ship.genesisTorpedos() - buyTorps.getInteger();
			} else {
				buyTorp = 0;
			}
		
			SendMacro.exec("ha"+buyAtom+"^mt"+buyTorp+"^mqq/", 1, false);	

			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(50); }

			DisplayCurrentInfo.exec(true);

			try {
				TransWarp.exec(Basket.sector());
			}
			catch (Exception e) {
				output("Unable to warp home.");
				throw new ScriptException("Unable to warp home");
			}
			JettisonCargo.exec();				
		}
	}

	public void Mover(int Prod, int HowMuch) throws Exception {
		int holds = Swath.ship.holds();	// Ships Holds
		int Carry = 0;				// what we're taking in a trip
		int foe = 0;
		int amnt = 0;				// total amount
		int iter = 0;
		int legs = 0;
		int last = 0;
		int t = 0;

		amnt = HowMuch;
		
		switch (Prod) {
			case Swath.FUEL_ORE:
				foe = 1;
				if (amnt > FMax) { amnt = FMax; }	// This prevents us from trying to  put
				break;					// priduct on the planet than the Maximum
			case Swath.ORGANICS:				// If the planet is full ?Max will be zero.
				foe = 2;
				if (amnt > OMax) { amnt = OMax; }
				break;
			case Swath.EQUIPMENT:
				foe = 3;
				if (amnt > EMax) { amnt = EMax; }
				break;
			default:
				output("Attempted to Move non-existant product, contact your service dealer");
				throw new ScriptException("Unkown Product. Not known FOE");
		}

		iter = amnt / holds;					// Number of Macro cycles
		t = (iter * holds);					// iter will be zero if the planet's full.

		if (t < amnt) {						// Round about way of getting remainder
			last = amnt-t;					// 10,000 / 255holds=39.215
		}								// last = 10,000 - (39*255) = 9945
										// last = 55
		if (iter > 100) {						// do the job in legs
			while (iter > 0) {				// 
				if (iter > 100) {				// if iter is still > 100
					legs = 100;				// do another 100 cycle leg
					iter = iter-100;			//
				} else {					// else do what ever remains
					legs = iter;
					iter = 0;
				}
				SendMacro.exec("TNT"+foe+holds+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",legs,false);
			}
		} else {							// there isn't more than 100 cycles
			SendMacro.exec("TNT"+foe+holds+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",iter,false);
		}

		if (last > 0) {						// get last little bit
			SendMacro.exec("TNT"+foe+last+"^MQL"+Basket.id()+"^MTNL"+foe+"^MQL"+ToEmpty.id()+"^M",1,false);
		}
	}

	public void getMaxAmounts() throws Exception {
		if (planets.length > 0) {
			for (int i = 0; i < planets.length; i++) {
				if (planets[i].name().equals(Basket.className())) {
					MaxAmounts = planets[i].maxAmounts();
					FMax = MaxAmounts[Swath.FUEL_ORE] - PAmounts[Swath.FUEL_ORE];
					OMax = MaxAmounts[Swath.ORGANICS] - PAmounts[Swath.ORGANICS];
					EMax = MaxAmounts[Swath.EQUIPMENT]- PAmounts[Swath.EQUIPMENT];
					output("Planet can house [F/O/E] "+NumberFormat.getInstance().format(FMax)+" / "+NumberFormat.getInstance().format(OMax)+" / "+NumberFormat.getInstance().format(EMax));
				}
			}
		} else {
			String s = " *** Unable to obtain Maximum Planet Product values ***";
			output(s);
			throw new ScriptException(s);
		}
	}

	public void UpdateShipSpec() throws Exception {
		if (Swath.main.prompt() == Swath.COMMAND_PROMPT) {		
			JettisonCargo.exec();
			DisplayCurrentInfo.exec();
			EnterComputer.exec();
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			ChangeSettings.exec(ChangeSettings.ALL_KEYS);	// MD's userdfined routine
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			SendString.exec(";");
			while (Swath.main.prompt() != Swath.COMPUTER_PROMPT) { Thread.sleep(50); }
			LeaveComputer.exec();
			while (Swath.main.prompt() != Swath.COMMAND_PROMPT) { Thread.sleep(50); }
		}
	}

	public void WhosPlaying() throws Exception {
		Trader[] w; 
		String s = "Who's Playing: ";

		w = ShowWhoIsPlaying.exec();
		
		if (w.length > 0) {
			for (int i = 0; i < w.length; i++) {
				s = s + w[i].name() + ", ";
			}
		} else { s = s+"No one."; }
		output(s);
	}

	public void PlanetStat(Planet PlanetParam) throws Exception {
		PlanetClass[] planets;
		int[] MaxAmounts;
		int[] ColsReq;
		int[] Cols;
		int[] Prod;
		Planet P = PlanetParam;
		int c = 0;
		String s0 = "";
		//String s1 = "Planet #"+P.id()+" in sector "+P.sector()+": "+P.name();
		String s1 = "Planet #"+P.id()+" in sector *CLASSIFIED*: "+P.name();
		String s2 = "Class "+P.type()+", "+P.className();
		String s3 = "Created by: "+P.creator().name();
		String s4 = "Claimed by: "+P.owner();
		String s5 = " ";
		String s6 = "  Item    Colonists  Colonists   Planet     Farmed     Planet";	
		String s7 = "           (1000s)   2 Build 1   Amount     Amount     Maximum";	
		String s8 = " -------  ---------  ---------  ---------  ---------  ---------";
		String s9 = "Fuel Ore ";
		String s10= "Organics ";
		String s11= "Equipment";
		String s12= "Fighters ";
		String s = "'\r";

		planets = Swath.getAllPlanetClasses();	// Swath.ORGANICS  Swath.EQUIPMENT
		
		for (int i = 0; i < planets.length; i++) {
			if (planets[i].name().equals(P.className())) {
				Cols = P.colonists();					// Colonists (1000s)
				ColsReq = planets[i].colos2build1();		// Colonists 2 Build 1
				Prod = P.productAmounts();				// Planet Amount
				MaxAmounts = planets[i].maxAmounts();		// Planet Maximum

				s0 = s9 + Adjust(NumberFormat.getInstance().format(Cols[Swath.FUEL_ORE]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(ColsReq[Swath.FUEL_ORE]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(Prod[Swath.FUEL_ORE]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(FTot))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(MaxAmounts[Swath.FUEL_ORE]))+" ";
				s0 = s0 + "\r";
				s0 = s0 + s10 + Adjust(NumberFormat.getInstance().format(Cols[Swath.ORGANICS]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(ColsReq[Swath.ORGANICS]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(Prod[Swath.ORGANICS]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(OTot))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(MaxAmounts[Swath.ORGANICS]))+" ";
				s0 = s0 + "\r";
				s0 = s0 + s11 + Adjust(NumberFormat.getInstance().format(Cols[Swath.EQUIPMENT]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(ColsReq[Swath.EQUIPMENT]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(Prod[Swath.EQUIPMENT]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(ETot))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(MaxAmounts[Swath.EQUIPMENT]))+" ";
				s0 = s0 + "\r";
			}
		}
		s = s+s1+"\r"+s2+"\r"+s3+"\r"+s4+"\r"+s5+"\r"+s6+"\r"+s7+"\r"+s8+"\r"+s0+"\r\r";
		SendString.exec(s);
	}

	public void output(String message) throws Exception {
		String m = message;

		if (output.getCurrentChoice() == 0) {
			UserAlert.exec(m, UserAlert.TYPE_INFORMATION);		
		} else if (output.getCurrentChoice() == 1) {
			SendSSRadioMessage.exec(m);
		} else {
			// Do nothing
		}
	}

	public String Adjust(String ToFix) throws Exception {
		String s = ToFix;
		String t = "";
		int c = 0;
		int i = s.length();
		
		if (i < 10) {					//add leading " " spaces.
			for (c = 0; c < (10-i); c++) {
				t = t + " ";
			}
			t = t+s;
		} else {						//shorten string
			t = s.substring(i-10);
		}
		return t;
	}
}


