import com.swath.*;
import com.swath.cmd.*;
import java.util.*;
import java.text.*;

public class Plot extends UserDefinedScript {
	public String getName() {		return "Plot"; }
	public String getDescription() {	return "Plot"; }

	public boolean initScript() throws Exception {
		if (!atPrompt(Swath.PLANET_PROMPT)) { 
			throw new ScriptException("Wrong! Be on a planet!");
		}
		return true;
	}	

	public boolean runScript() throws Exception {
		Planet pp = Swath.getPlanet(Swath.main.currPlanet());

		PlanetStat(pp);

		return true;
	}

	public void PlanetStat(Planet PlanetParam) throws Exception {
		PlanetClass[] planets;
		int[] MaxAmounts;
		int[] ColsReq;
		int[] Cols;
		int[] Prod;
		Planet P = PlanetParam;
		int c = 0;
		String s0 = "";
		String s1 = "Planet #"+P.id()+" in sector "+P.sector()+": "+P.name();
		String s2 = "Class "+P.type()+", "+P.className();
		String s3 = "Created by: "+P.creator().name();
		String s4 = "Claimed by: "+P.owner();
		String s5 = " ";
		String s6 = "  Item    Colonists  Colonists   Planet     Farmed     Planet";	
		String s7 = "           (1000s)   2 Build 1   Amount     Amount     Maximum";	
		String s8 = " -------  ---------  ---------  ---------  ---------  ---------";
		String s9 = "Fuel Ore ";
		String s10= "Organics ";
		String s11= "Equipment";
		String s12= "Fighters ";
		String s = "'\r";

		planets = Swath.getAllPlanetClasses();	// Swath.ORGANICS  Swath.EQUIPMENT
		
		for (int i = 0; i < planets.length; i++) {
			if (planets[i].name().equals(P.className())) {
				Cols = P.colonists();					// Colonists (1000s)
				ColsReq = planets[i].colos2build1();		// Colonists 2 Build 1
				Prod = P.productAmounts();				// Planet Amount
				MaxAmounts = planets[i].maxAmounts();		// Planet Maximum

				s0 = s9 + Adjust(NumberFormat.getInstance().format(Cols[Swath.FUEL_ORE]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(ColsReq[Swath.FUEL_ORE]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(Prod[Swath.FUEL_ORE]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(10000000))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(MaxAmounts[Swath.FUEL_ORE]))+" ";
				s0 = s0 + "\r";
				s0 = s0 + s10 + Adjust(NumberFormat.getInstance().format(Cols[Swath.ORGANICS]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(ColsReq[Swath.ORGANICS]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(Prod[Swath.ORGANICS]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(1000000))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(MaxAmounts[Swath.ORGANICS]))+" ";
				s0 = s0 + "\r";
				s0 = s0 + s11 + Adjust(NumberFormat.getInstance().format(Cols[Swath.EQUIPMENT]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(ColsReq[Swath.EQUIPMENT]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(Prod[Swath.EQUIPMENT]))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(1000000))+" ";
				s0 = s0 + Adjust(NumberFormat.getInstance().format(MaxAmounts[Swath.EQUIPMENT]))+" ";
				s0 = s0 + "\r";
			}
		}

		s = s+s1+"\r"+s2+"\r"+s3+"\r"+s4+"\r"+s5+"\r"+s6+"\r"+s7+"\r"+s8+"\r"+s0+"\r\r";

		SendString.exec(s);
	}

	public String Adjust(String ToFix) throws Exception {
		String s = ToFix;
		String t = "";
		int c = 0;
		int i = s.length();
		
		if (i < 10) {					//add leading " " spaces.
			for (c = 0; c < (10-i); c++) {
				t = t + " ";
			}
			t = t+s;
		} else {						//shorten string
			t = s.substring(i-10);
		}
		return t;
	}
}


