import com.swath.*;
import com.swath.cmd.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class TunnelFinder2 extends UserDefinedScript {
	private int[] SecLst;
	private Parameter Cycle;

	public String getName() {		return "TunnelFinder2"; }
	public String getDescription() {	return "Tunnel Finder2"; }

	public boolean initScript() throws Exception {
		Cycle = new Parameter("Sectors to Search");
		Cycle.setType(Parameter.INTEGER);
		Cycle.setIntegerRange(1, Swath.main.sectors());
		Cycle.setInteger(1000);
		registerParam(Cycle);

		SecLst = new int[Swath.main.sectors()+1];
		Arrays.fill(SecLst, 0);

		return true;
	}	

	public boolean runScript() throws Exception {

		//output("[] Plotting "+Cycle.getInteger()+" course paths");
		for (int i = 11; i < Cycle.getInteger(); i++) {
			Ploti(1, i); 
		}
		output("[] Writing to file Sectors with 2warps adj to two-warp Sectors.");
		WriteFile();
		output("fini");
		return true;
	}

	public void Ploti(int f, int t) throws Exception {
		int[] c = Tools.findRoute(f, t, true);

		for (int i=0; i < c.length; i++) {
			SecLst[c[i]] += 1;
		}
	}

	public void WriteFile() throws Exception {
		int d = 0;
		BufferedWriter f;

		f = new BufferedWriter(new FileWriter("c://"+Swath.main.gameName()+"_MAJ.txt"));

		f.write("Sector ][ Number of Hits ][ Number of Warps out");
		f.newLine();

		for (int i = 0; i < SecLst.length; i++) {
			if ((SecLst[i] > 0) && (SecLst[i] < 10)) {		
				d = Tools.getDistance(1, i, true);
				if(d > 10) {	
					Sector s = Swath.getSector(i);
					if (s.warps() == 2) {
						int [] secs = s.warpSectors();
						Sector s1 = Swath.getSector(secs[0]);
						if (s1.warps() == 2) {
							Sector s2 = Swath.getSector(secs[1]);
							if (s2.warps() == 2) {
								f.write(i + " - " + SecLst[i] + "   Distance: "+d);
								f.newLine();
							}
						}
					}
				}
			}
		}

		f.close();
	}

	public void output(String message) throws Exception {
		String m = message;

		//SendSSRadioMessage.exec(m);
		UserAlert.exec(m,UserAlert.TYPE_INFORMATION);
	}
}


